import 'package:intl/intl.dart';
import 'package:google_maps_flutter/google_maps_flutter.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:url_launcher/url_launcher.dart';
import 'package:encrypt/encrypt.dart';
import '../../theme.dart';


abstract class Constant{

  static const String APP_NAME = 'Quick Delivery';
  static const bool ENABLE_LOGS = false;
  static const int ROW_PER_PAGE = 10;
  static const bool TESTING_MODE = false;
  static const String BASE_URL_PRIMARY = "https://api.quick.com.mm/delivery-backend-v3";
  static const String BASE_URL_DEV = "https://dev.quick.com.mm/delivery-backend-v2";
  static const String CONTACT_PHONE = '+959 123 435 456';
  static const String THEME_NAME_BRANDED_DEFAULT = Constant.THEME_NAME_ORANGE;
  static const bool THEME_CHANGABLE = true;
  static const String OFFICE_ADDRESS = "123, Shwe Gone Daing Rd, Yangon, Myanmar";
  static const int CODE_VERSION = 25;
  static const String UI_DOMAIN_NAME = "quickdoor2door.com";
  static const LatLng OFFICE_LOCATION= LatLng(16.813538,96.171205);
  static const String SHARE_MODE = "link";//print,remotePrint,link
  static const String UI_DOMAIN_NAME_SHARE = "https://v3.quickdoor2door.com/delivery_details/";
  static const bool SHOW_CREATED_WAYS_TO_DELIVERYMAN = false;
  static const bool ENABLE_HR_MODULE = true;


  static const String CURRENT_DEVICE_TOKEN_VALUE = "cdtv";
  static const String CURRENT_DEVICE_TOKEN_EXPIRED = "cdte";
  static const String CURRENT_USER_TOKEN_VALUE = "cutv";
  static const String CURRENT_USER_REFRESH_TOKEN_VALUE = "curtv";
  static const String CURRENT_USER_TOKEN_EXPIRED = "cute";
  static const String CURRENT_USER_DATA = "cud";
  static const String CURRENT_USER_DATA_EXT_EMPLOYEE = "cudEExt";
  static const String CURRENT_USER_DATA_AUTHORITY = "cudauth";
  static const String FIREBASE_TOKEN_KEY = "gfmtk";
  static const String DEVICE_GUID = "udvg";
  static const String CURRENT_KIOSK_DATA = "ckd";
  static const String KIOSK_SETTINGS_AUTO_ATTENDANCE = "ksauto";
  static const String KIOSK_SETTINGS_DETECTION_DISTANCE = "ksdd";
  static const String KIOSK_SETTINGS_TIME_INTERVAL = "ksti";
  static const String KIOSK_SETTINGS_SCREEN_TIMEOUT = "kssto";
  static const String KIOSK_SETTINGS_MULTI_FACES = "ksmf";
  static const String KIOSK_SETTINGS_IN_OUT_MODE = "ksio";
  // static const String SETTINGS_ATTENDANCE_SHARING = "sasing";
  static const String SETTINGS_PUNCH_IN_REMINDER = "spir";
  static const String SETTINGS_PUNCH_OUT_REMINDER = "spor";
  static const String CAMPAIGN_LAST_ID = "camlid";
  static const String LANGUAGE = "language";
  static const String CAMERA_SHUTTER_SOUND = "cssound";
  static const String AUTHENTICATION_2FA = "a2fa";
  static const String CURRENT_ORG_DATA = "corg";

  static const String PLATFORM_ANDROID = "Android";
  static const String PLATFORM_IOS = "iOS";
  static const String SALTED_KEY_32 = "ThJZU422uyDsGkvW2fn8xAPH452nrKeJ";
  static const String BASE_URL_STORAGE = "bustrge";
  static const String NOTIFICATION_PAYLOAD_DEFAULT = 'notification';
  static const String LANGUAGE_CODE_MY = "my";
  static const String LANGUAGE_CODE_EN = "en";

  static const String EMPLOYEE_STATUS_ACTIVE = "Active";
  static const String EMPLOYEE_STATUS_TERMINATED = "Terminated";
  static const int HTTP_OK = 200;
  static const int HTTP_CREATE = 201;
  static const int HTTP_DENIED = 401;
  static const String IMAGE_DOWNLOAD_BASE_URL = "/v3/image/download/";


  /******************* Deli*/
  static const String STATUS_CREATED = "Created";
  static const String STATUS_ASSIGNED = "Assigned";
  static const String STATUS_ON_WAY = "OnWay";
  static const String STATUS_RETURN = "Return";
  static const String STATUS_RETURNED = "Returned";
  static const String STATUS_RETRY = "Retry";
  static const String STATUS_CANCELED = "Canceled";
  static const String STATUS_INCOMPLETE = "Incomplete";
  static const String STATUS_INACTIVE = "Inactive";
  static const String STATUS_COMPLETED = "Completed";
  static const String STATUS_PICKUP_CREATED = "PickupCreated";
  static const String STATUS_PICKUP_SCHEDULED = "PickupScheduled";
  static const String STATUS_PICKUP_ON_WAY = "PickupOnWay";
  static const String CONTACT_TYPE_PICKUP = "Pickup";
  static const String CONTACT_TYPE_DROP_OFF = "Drop-off";
  static const String CONTACT_TYPE_PICKUP_EMPLOYEE = "Pickup Employee";
  static const String CONTACT_TYPE_DROP_OFF_EMPLOYEE = "Drop-off Employee";
  static const String ADDRESS_TYPE_OS = "OS";
  static const String ADDRESS_TYPE_CUSTOMER = "Customer";
  static const String ADDRESS_TYPE_EMPLOYEE = "Employee";
  static const String ADDRESS_TYPE_HIGHWAY = "Highway Gate";
  static const String ADDRESS_TYPE_POST_OFFICE = "Post Office";
  static const String ADDRESS_TYPE_POI = "POI";
  static const String ROLE_NAME_OS = "OS";
  static const String ROLE_NAME_CUSTOMER = "Customer";
  static const String ROLE_NAME_EMPLOYEE = "Employee";
  static const String ROLE_NAME_MANAGER = "Manager";
  static const String ROLE_NAME_ADMINISTRATOR = "Administrator";
  static const String SETTINGS_TEMP_LOGIN = "stl";
  static const String CONNECTION_OK = "OK";
  static const String CONNECTION_REFUSED = "REFUSED";
  static const String CONNECTION_DENIED = "DENIED";
  static const String CONNECTION_BAD_REQUEST = "BAD_REQUEST";
  static const String STATUS_BUCKET="Bucket";
  static const String BUCKET_STATUS_REQUEST = "Request";
  static const String BUCKET_STATUS_ACCEPT = "Accept";
  static const String BUCKET_STATUS_REJECT = "Reject";
  static const String STATUS_COMPLETED_AND_BUCKET_STATUS_REQUEST="CompletedAndRequest";

  static const String THEME_NAME_ORANGE = "orange";
  static const String THEME_NAME_GOLD = "gold";
  static const String THEME_NAME_GREEN = "green";
  static const String THEME_NAME_BLUE = "blue";
  static const String THEME_NAME_RED = "red";
  static const String THEME_NAME_DARK_MODE = "dark";
  static const String SETTING_THEME = "myTheme";

//Pickup, Dropoff, Pickup Employee, Drop-off Employee
}

String toUTCShortFormat(DateTime dateTime){
  DateFormat dateFormat = DateFormat("yyyy-MM-dd");
  return dateFormat.format(dateTime.toUtc());
}

String toUTCLongFormat(DateTime dateTime){
  DateFormat dateFormat = DateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
  return dateFormat.format(dateTime.toUtc());
}

Future<bool> getKioskSettingsAutoAttendance( ) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  return sharedPrefs.getBool(Constant.KIOSK_SETTINGS_AUTO_ATTENDANCE)?? true;
}
Future<void> setKioskSettingsAutoAttendance( bool autoAttendance) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  sharedPrefs.setBool( Constant.KIOSK_SETTINGS_AUTO_ATTENDANCE, autoAttendance);
}


Future<double> getKioskSettingsFaceDetectionDistance( ) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  return sharedPrefs.getDouble( Constant.KIOSK_SETTINGS_DETECTION_DISTANCE )?? 1.0;
}
Future<void> setKioskSettingsFaceDetectionDistance( double distance ) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  sharedPrefs.setDouble( Constant.KIOSK_SETTINGS_DETECTION_DISTANCE, distance );
}

Future<int> getKioskSettingsTimeIntervalMinutes( ) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  return sharedPrefs.getInt(Constant.KIOSK_SETTINGS_TIME_INTERVAL)?? 120;
}
Future<void> setKioskSettingsTimeIntervalMinutes( double interval) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  sharedPrefs.setInt(Constant.KIOSK_SETTINGS_TIME_INTERVAL, (interval*60).toInt() );
}

Future<bool> getKioskSettingsScreenAlwaysOn( ) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  return sharedPrefs.getBool(Constant.KIOSK_SETTINGS_SCREEN_TIMEOUT)?? true;
}
Future<void> setKioskSettingsScreenAlwaysOn( bool autoAttendance) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  sharedPrefs.setBool( Constant.KIOSK_SETTINGS_SCREEN_TIMEOUT, autoAttendance);
}

Future<bool> getKioskSettingsMultipleFaces( ) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  return sharedPrefs.getBool(Constant.KIOSK_SETTINGS_MULTI_FACES)?? false;
}
Future<void> setKioskSettingsMultipleFaces( bool autoAttendance) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  sharedPrefs.setBool( Constant.KIOSK_SETTINGS_MULTI_FACES, autoAttendance);
}



Future<bool> getKioskSettingsInOutMode( ) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  return sharedPrefs.getBool(Constant.KIOSK_SETTINGS_IN_OUT_MODE)?? true;
}
Future<void> setKioskSettingsInOutMode( bool autoAttendance) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  sharedPrefs.setBool( Constant.KIOSK_SETTINGS_IN_OUT_MODE, autoAttendance);
}

Future<bool> getSettingsTempLogin( ) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  return sharedPrefs.getBool(Constant.SETTINGS_TEMP_LOGIN)?? false;
}
Future<void> setSettingsTempLogin( bool autoAttendance) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  sharedPrefs.setBool( Constant.SETTINGS_TEMP_LOGIN, autoAttendance);
}


Future<double> getSettingsPunchInReminder( ) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  return sharedPrefs.getDouble( Constant.SETTINGS_PUNCH_IN_REMINDER )?? 15;
}
Future<void> setSettingsPunchInReminder( double distance ) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  sharedPrefs.setDouble( Constant.SETTINGS_PUNCH_IN_REMINDER, distance );
}

Future<double> getSettingsPunchOutReminder( ) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  return sharedPrefs.getDouble( Constant.SETTINGS_PUNCH_OUT_REMINDER )?? 5;
}
Future<void> setSettingsPunchOutReminder( double distance ) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  sharedPrefs.setDouble( Constant.SETTINGS_PUNCH_OUT_REMINDER, distance );
}

Future<int> getCampaignLastId( ) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  return sharedPrefs.getInt(Constant.CAMPAIGN_LAST_ID)?? 0;
}
Future<void> setCampaignLastId( int campaignLastId) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  sharedPrefs.setInt(Constant.CAMPAIGN_LAST_ID, campaignLastId );
}

Future<String> getLanguage( ) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  return sharedPrefs.getString(Constant.LANGUAGE)?? (DateTime.now().timeZoneOffset.inMinutes==390? Constant.LANGUAGE_CODE_MY : Constant.LANGUAGE_CODE_EN);
}
Future<void> setLanguage( String language) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  sharedPrefs.setString(Constant.LANGUAGE, language );
}

Future<bool> getCameraShutterSoundNotice( ) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  return sharedPrefs.getBool(Constant.CAMERA_SHUTTER_SOUND)?? true;
}
Future<void> setCameraShutterSoundNotice( bool sound) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  sharedPrefs.setBool( Constant.CAMERA_SHUTTER_SOUND, sound);
}

Future<bool> get2FA( ) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  return sharedPrefs.getBool(Constant.AUTHENTICATION_2FA)?? false;
}
Future<void> set2FA( bool a2fa) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  sharedPrefs.setBool( Constant.AUTHENTICATION_2FA, a2fa);
}

void makeCall( String phone ) async{
  if (await canLaunch('tel:$phone')) {
    await launch('tel:$phone');
  } else {
    throw 'Could not launch $phone';
  }
}

void openBrowser( String url ) async{
  print(url);
  if (await canLaunch('$url')) {
    await launch(url);
  } else {
    throw 'Could not launch $url';
  }
}

Future<String> setBaseURL( String url ) async{
  final key = Key.fromUtf8( Constant.SALTED_KEY_32 );
  final iv = IV.fromLength(16);
  final encrypter = Encrypter(AES(key));
  final encrypted = encrypter.encrypt(url, iv: iv);
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  sharedPrefs.setString( Constant.BASE_URL_STORAGE, encrypted.base64);
  return encrypted.base64;
}

String getBaseURL( SharedPreferences sharedPrefs ) {

  if( Constant.TESTING_MODE)
    return Constant.BASE_URL_DEV;

  String encrypted = sharedPrefs.getString(Constant.BASE_URL_STORAGE)?? '';

  if( encrypted == ''){
    return Constant.BASE_URL_PRIMARY;
  }else{
    final key = Key.fromUtf8( Constant.SALTED_KEY_32 );
    final iv = IV.fromLength(16);
    final encrypter = Encrypter(AES(key));
    final decrypted = encrypter.decrypt(Encrypted.fromBase64(encrypted), iv: iv);

    return decrypted;
  }
}

Future<String> getTheme( ) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  return sharedPrefs.getString(Constant.SETTING_THEME)?? Constant.THEME_NAME_BRANDED_DEFAULT;
}
Future<void> setTheme( String theme) async{
  final SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
  sharedPrefs.setString( Constant.SETTING_THEME, theme);
}

dynamic getDefaultTheme( String name ) {
  if( name == Constant.THEME_NAME_BLUE)
    return blueTheme;
  else if( name == Constant.THEME_NAME_RED)
    return redTheme;
  else if( name == Constant.THEME_NAME_GOLD)
    return goldTheme;
  else if( name == Constant.THEME_NAME_GREEN)
    return greenTheme;
  else if( name == Constant.THEME_NAME_ORANGE)
    return orangeTheme;
  else
    return darkTheme;
}