

class Notification{

  static const String STATUS_READ = "Read";
  static const String STATUS_UNREAD = "Unread";
  static const int TYPE_PROMOTION = 1;
  static const int TYPE_ALERT = 2;
  static const int TYPE_NOTIFICATION = 3;
  static const int TYPE_UPDATE = 4;
  static const int TYPE_CHAT = 5;

  int campaignId;
  String appId;
  int campaignTypeId;
  DateTime scheduleAt;
  String title;
  String description;
  String url;
  int targetId;
  String target;
  String status;
  String brief;


  Notification({this.campaignId, this.appId, this.campaignTypeId, this.scheduleAt,
    this.title, this.description, this.url, this.targetId, this.target, this.status, this.brief});

  Map<String, dynamic> toMap() {
    return {
      'campaignId': campaignId,
      'appId': appId,
      'campaignTypeId': campaignTypeId,
      'scheduleAt': scheduleAt.millisecondsSinceEpoch,
      'title': title,
      'description': description,
      'url': url,
      'targetId': targetId,
      'target': target,
      'status': status,
      'brief': brief
    };
  }

  fromMap( Map<String, dynamic> data ) async{
    if( data == null) return;
    campaignId= data['campaignId'];
    appId= data['appId'];
    campaignTypeId= data['campaignTypeId'];
    scheduleAt= DateTime.fromMillisecondsSinceEpoch(data['scheduleAt']);
    title= data['title'];
    description= data['description'];
    url= data['url'];
    targetId= data['targetId'];
    target= data['target'];
    status= data['status'];
    brief= data['brief'];
  }

  Future<Notification> fromMessage( Map<String, dynamic> data ) async{
    if( data == null) return null;
    return Notification(
      campaignId: int.parse(data['campaignId']),
      appId: data['appId'],
      campaignTypeId: int.parse(data['campaignTypeId']),
      scheduleAt: DateTime.parse(data["scheduleAt"]),
      title: data['title'],
      description: data['description'],
      url: data['url'],
      targetId: data['targetId']!=null && data['targetId'].toString().isNotEmpty ? int.parse(data['targetId']) : null,
      target: data['target'],
      status: STATUS_UNREAD,
      brief: data['brief']
    );
  }

  fromJson( Map<String, dynamic> data ) async{
    if( data == null) return;

    campaignId= data['campaignId'];
    appId= data['appId'];
    campaignTypeId= data['campaignTypeId'];
    scheduleAt= DateTime.parse(data["scheduleAt"]);
    title= data['title'];
    description= data['description'];
    url= data['url'];
    targetId= data['targetId'];
    target= data['target'];
    status= STATUS_UNREAD;
    brief= data['brief'];
  }
}