import 'package:qq_delivery/delivery/config/constant.dart';
import 'package:equatable/equatable.dart';
import 'dart:convert';
import 'package:shared_preferences/shared_preferences.dart';


class User extends Equatable {
  String name;
  String guid;
  String avatar;
  String roleName;
  String branchGuid;
  String branchType;
  String supervisorGuid;
  bool verified;
  bool agree;
  double latitude;
  double longitude;
  String phone;

User({this.name, this.guid, this.avatar, this.roleName, this.branchGuid,
  this.branchType, this.supervisorGuid});

  @override
  List<Object> get props => [name, guid, avatar, roleName, branchGuid,
    branchType, supervisorGuid];

  @override
  String toString() => this.name;

  Future<bool> fromJson(String json, bool save) async{
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];
      name = data["name"];
      guid = data["guid"];
      avatar = data["avatar"];
      roleName = data["roleName"];
      branchGuid = data["branchGuid"];
      branchType = data["branchType"];
      supervisorGuid = data["supervisorGuid"];
      verified = data["verified"];
      agree = data["agree"];
      latitude = data["latitude"];
      longitude = data["longitude"];
      phone = data["phone"];

      if( save) {
        SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
        sharedPrefs.setString(Constant.CURRENT_USER_DATA, json);
      }
      return true;
    }else{
      return false;
    }
  }

  Future<void> fromSharedPreferences() async{
    SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
    if( sharedPrefs.getString(Constant.CURRENT_USER_DATA) != null){
      await fromJson(sharedPrefs.getString(Constant.CURRENT_USER_DATA), false);
    }
  }

}