
import 'package:equatable/equatable.dart';

class DeliveryCompletedRequest extends Equatable{
  String contentGuid;
  double labourCost;
  double transportCost;
  double extraCost;
  String customerSign;
  String assigneeSign;
  String comment;
  double latitude;
  double longitude;
  bool fullCollected;
  double finalCashCollected;
  double nonCashCollected;
  String receivedOption;//Cash, Bank, E-money
  String receivedOptionName;//Cash, KPay, WavePay, AYA Bank, CB Bank, etc.
  String nonCashTransferTo;//Office, Merchant
  String reasonOfReduceAmount; // DeliveryFeeReduce, ReduceFromMerchant

  DeliveryCompletedRequest({this.contentGuid, this.labourCost, this.transportCost,
   this.extraCost, this.customerSign, this.assigneeSign, this.comment,
  this.latitude, this.longitude, this.fullCollected, this.finalCashCollected,
  this.nonCashCollected, this.receivedOption, this.receivedOptionName,
  this.nonCashTransferTo, this.reasonOfReduceAmount});
  @override
  List<Object> get props => [contentGuid, labourCost, transportCost, extraCost,
    customerSign, assigneeSign, comment, latitude, longitude, fullCollected,
    finalCashCollected, nonCashCollected, receivedOption, receivedOptionName,
    nonCashTransferTo, reasonOfReduceAmount];
  @override
  String toString() => '${this.contentGuid}';

  Map<String, dynamic> toMap(){
    Map<String, dynamic> data = {
      'contentGuid': contentGuid,
      'labourCost': labourCost,
      'transportCost': transportCost,
      'extraCost': extraCost,
      'customerSign': customerSign,
      'assigneeSign': assigneeSign,
      'comment': comment,
      'latitude':latitude,
      'longitude':longitude,
      'fullCollected':fullCollected,
      'finalCashCollected':finalCashCollected,
      'nonCashCollected':nonCashCollected,
      'receivedOption':receivedOption,
      'receivedOptionName':receivedOptionName,
      'nonCashTransferTo':nonCashTransferTo,
      'reasonOfReduceAmount':reasonOfReduceAmount,
    };
    return data;
  }
}