import 'package:equatable/equatable.dart';
import 'package:intl/intl.dart';



class DeliveryCountByStatusRequest extends Equatable{
  String branchGuid;
  DateTime startDate;
  DateTime endDate;
  String dateParam;
  String filter;

  DeliveryCountByStatusRequest({this.branchGuid, this.startDate, this.endDate,
  this.dateParam, this.filter});
  @override
  List<Object> get props => [branchGuid, startDate, endDate, dateParam, filter];
  @override
  String toString() => '${this.branchGuid}';

  Map<String, dynamic> toMap(){
    Map<String, dynamic> data = {
      'branchGuid': branchGuid,
      'startDate': startDate!=null? new DateFormat('yyyy-MM-dd').format(startDate.toLocal()): null,
      'endDate': endDate!=null? new DateFormat('yyyy-MM-dd').format(endDate.toLocal()) : null,
      'dateParam': dateParam??'month',
      'filter': filter
    };
    return data;
  }
}