import 'package:equatable/equatable.dart';
import 'package:intl/intl.dart';



class DeliveryListRequest extends Equatable{

  String keyword;
  DateTime startDate;
  DateTime endDate;
  String osGuid;
  String customerGuid;
  String employeeGuid;
  String zoneGuid;
  String branchGuid;
  List<String> status;
  int first;
  int max;
  String orderBy;
  bool asc;
  String pickupGuid;
  String dateParam;
  String wayType;
  String filter;
  String dateType;


  DeliveryListRequest({this.keyword, this.startDate, this.endDate, this.osGuid,
  this.customerGuid, this.employeeGuid, this.zoneGuid, this.branchGuid, this.status,
  this.first, this.max, this.orderBy, this.asc, this.pickupGuid,
  this.dateParam, this.wayType, this.filter, this.dateType});
  @override
  List<Object> get props => [keyword, startDate, endDate, osGuid,
    customerGuid, employeeGuid, zoneGuid, branchGuid, status,
    first, max, orderBy, asc, pickupGuid, dateParam, wayType, filter, dateType];
  @override
  String toString() => '${this.branchGuid}';

  Map<String, dynamic> toMap(){
    Map<String, dynamic> data = {
      'keyword': keyword,
      'startDate': startDate!=null? new DateFormat('yyyy-MM-dd').format(startDate.toLocal()): null,
      'endDate': endDate!=null? new DateFormat('yyyy-MM-dd').format(endDate.toLocal()) : null,
      'osGuid': osGuid,
      'customerGuid': customerGuid,
      'employeeGuid': employeeGuid,
      'zoneGuid': zoneGuid,
      'branchGuid': branchGuid,
      'status': status,
      'first': first,
      'max': max,
      'orderBy': orderBy,
      'asc': asc,
      'pickupGuid' : pickupGuid,
      'dateParam': dateParam,
      'wayType': wayType,
      'filter': filter,
      'dateType': dateType,
    };
    return data;
  }
}