import 'package:equatable/equatable.dart';
import 'package:intl/intl.dart';


class EmpployeeClearanceListRequest extends Equatable{
  DateTime startDate;
  DateTime endDate;
  String employeeGuid;
  String zoneGuid;
  String branchGuid;
  String status;
  int first;
  int max;
  String orderBy;
  bool asc;
  String keyword;
  String wayType;

  EmpployeeClearanceListRequest({this.startDate, this.endDate, this.employeeGuid,
    this.zoneGuid, this.branchGuid, this.status, this.first,
    this.max, this.orderBy, this.asc, this.keyword, this.wayType});

  @override
  List<Object> get props => [startDate, endDate, employeeGuid, zoneGuid,
    branchGuid, status, first, max, orderBy, asc, keyword, wayType];

  @override
  String toString() => '${this.status}';


  Map<String, dynamic> toMap(){
    Map<String, dynamic> data = {
      'startDate': startDate!=null? new DateFormat('yyyy-MM-dd').format(startDate.toLocal()): null,
      'endDate': endDate!=null? new DateFormat('yyyy-MM-dd').format(endDate.toLocal()) : null,
      'employeeGuid': employeeGuid,
      'zoneGuid': zoneGuid,
      'branchGuid': branchGuid,
      'status': status,
      'first': first,
      'max': max,
      'orderBy': orderBy,
      'asc': asc,
      'keyword': keyword,
      'wayType': wayType,
    };
    return data;
  }
}