import 'package:equatable/equatable.dart';
import 'package:intl/intl.dart';


class OSDepositRefundListRequest extends Equatable{
  DateTime startDate;
  DateTime endDate;
  String osGuid;
  String branchGuid;
  String type;
  int first;
  int max;
  String orderBy;
  bool asc;

  OSDepositRefundListRequest({this.startDate, this.endDate, this.osGuid,
    this.branchGuid, this.type, this.first, this.max, this.orderBy, this.asc});

  @override
  List<Object> get props => [startDate, endDate, osGuid, branchGuid, type,
    first, max, orderBy, asc];

  @override
  String toString() => '${this.type}';


  Map<String, dynamic> toMap(){
    Map<String, dynamic> data = {
      'startDate': startDate!=null? new DateFormat('yyyy-MM-dd').format(startDate.toLocal()): null,
      'endDate': endDate!=null? new DateFormat('yyyy-MM-dd').format(endDate.toLocal()) : null,
      'osGuid': osGuid,
      'branchGuid': branchGuid,
      'type': type,
      'first': first,
      'max': max,
      'orderBy': orderBy,
      'asc': asc,
    };
    return data;
  }
}