import 'dart:convert';
import 'package:equatable/equatable.dart';



class ActiveDeliverymanResponse extends Equatable{

  List<DeliveryForDeliveryItem> items;
  int totalRecords;


  ActiveDeliverymanResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final deliveryLitData = data["items"] as List;
      items = new List<DeliveryForDeliveryItem>();
      deliveryLitData.forEach((element) {
        DeliveryForDeliveryItem employeeForDeliveryItem = new DeliveryForDeliveryItem();
        employeeForDeliveryItem.fromMap(element);
        items.add(employeeForDeliveryItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}

class DeliveryForDeliveryItem extends Equatable{

  String name;
  String avatar;
  String guid;
  String personId;

  DeliveryForDeliveryItem({this.guid, this.name, this.avatar, this.personId});
  @override
  List<Object> get props => [guid, name, avatar, personId];
  @override
  String toString() => this.name;

  fromMap( Map<String, dynamic> data ){
    name = data["name"];
    avatar = data["avatar"];
    guid = data["guid"];
    personId = data["personId"]??'';
  }
}