import 'dart:convert';
import 'package:equatable/equatable.dart';



class ActivePrinterResponse extends Equatable{

  List<PrinterItem> items;
  int totalRecords;


  ActivePrinterResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final deliveryLitData = data["items"] as List;
      items = new List<PrinterItem>();
      deliveryLitData.forEach((element) {
        PrinterItem employeeForDeliveryItem = new PrinterItem();
        employeeForDeliveryItem.fromMap(element);
        items.add(employeeForDeliveryItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}

class PrinterItem extends Equatable{

  String name;
  bool active;
  String guid;
  bool available;
  DateTime createdOn;
  DateTime updatedOn;

  PrinterItem({this.guid, this.name, this.active, this.available, this.createdOn, this.updatedOn});
  @override
  List<Object> get props => [guid, name, active, available, createdOn, updatedOn];
  @override
  String toString() => this.name;

  fromMap( Map<String, dynamic> data ){
    name = data["name"];
    active = data["active"];
    guid = data["guid"];
    available = data["available"];
    createdOn = data["createdOn"]!=null? DateTime.parse(data["createdOn"]) : null;
    updatedOn = data["updatedOn"]!=null? DateTime.parse(data["updatedOn"]) : null;
  }
}