import 'dart:convert';
import 'package:equatable/equatable.dart';



class ActiveWayCountByTownResponse extends Equatable{

  List<ActiveWayCountByTownItem> items;
  int totalRecords;


  ActiveWayCountByTownResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final deliveryLitData = data["items"] as List;
      items = new List<ActiveWayCountByTownItem>();
      deliveryLitData.forEach((element) {
        ActiveWayCountByTownItem employeeForDeliveryItem = new ActiveWayCountByTownItem();
        employeeForDeliveryItem.fromMap(element);
        items.add(employeeForDeliveryItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}

class ActiveWayCountByTownItem extends Equatable{

  String town;
  int pickupCount;
  int deliverCount;

  ActiveWayCountByTownItem({this.town, this.pickupCount, this.deliverCount});
  @override
  List<Object> get props => [town, pickupCount, deliverCount];
  @override
  String toString() => this.town;

  fromMap( Map<String, dynamic> data ){
    town = data["town"];
    pickupCount = data["pickupCount"]??0;
    deliverCount = data["deliverCount"]??0;
  }
}