import 'dart:convert';
import 'package:qq_delivery/delivery/config/constant.dart';
import 'package:equatable/equatable.dart';
import 'package:shared_preferences/shared_preferences.dart';



class AuthorityResponse extends Equatable {
  List<String> scope;
  List<String> authorities;
  bool active;
  List<String>  aud;
  String userName;
  DateTime expire;
  String clientId;

  AuthorityResponse({this.scope, this.authorities, this.active, this.aud, this.userName, this.expire, this.clientId});
  @override
  List<Object> get props => [scope, authorities, active, aud, userName, expire, clientId];
  @override
  String toString() => this.userName;

  Future<bool> fromJson(String json, bool save) async{
    if( json == null) return false;

    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final scopeData = data["scope"] as List;
      scope = new List<String>();
      scopeData.forEach((element) {
        scope.add(element);
      });
      active = data["active"];

      final authoritiesData = data["authorities"] as List;
      authorities = new List<String>();
      authoritiesData.forEach((element) {
        authorities.add(element);
      });
      final audData = data["aud"] as List;
      aud = new List<String>();
      audData.forEach((element) {
        aud.add(element);
      });

      userName = data["user_name"];
      expire = DateTime.fromMillisecondsSinceEpoch(data["exp"]);
      clientId = data["client_id"];

      if( save) {
        SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
        sharedPrefs.setString(Constant.CURRENT_USER_DATA_AUTHORITY, json);
      }
      return true;
    }else{
      return false;
    }
  }

  Future<void> fromSharedPreferences() async{
    SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
    if( sharedPrefs.getString(Constant.CURRENT_USER_DATA_AUTHORITY) != null){
      await fromJson(sharedPrefs.getString(Constant.CURRENT_USER_DATA_AUTHORITY), false);
    }
  }

}