import 'dart:convert';
import 'package:equatable/equatable.dart';



class ChatGroupMemberListResponse extends Equatable{

  List<ChatGroupMemberItem> items;
  int totalRecords;


  ChatGroupMemberListResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final deliveryLitData = data["items"] as List;

      items=new List<ChatGroupMemberItem> ();
      deliveryLitData.forEach((element) {
        ChatGroupMemberItem deliveryListItem = new ChatGroupMemberItem();
        deliveryListItem.fromMap(element);
        items.add(deliveryListItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}

class ChatGroupMemberItem extends Equatable{
  String groupName;
  String groupGuid;
  String groupPhoto;
  String memberGuid;
  String memberName;
  String memberPhoto;
  String sessionGuid;
  String adminName;
  String adminGuid;

  ChatGroupMemberItem({this.groupName, this.groupGuid, this.groupPhoto, this.memberGuid,
  this.memberName, this.memberPhoto, this.sessionGuid, this.adminName, this.adminGuid});

  @override
  List<Object> get props => [groupName, groupGuid, groupPhoto, memberGuid,
    memberName, memberPhoto, sessionGuid, adminName, adminGuid];

  @override
  String toString() => this.groupName;

  fromMap( Map<String, dynamic> data ){
    groupName = data["groupName"];
    groupGuid = data["groupGuid"];
    groupPhoto = data["groupPhoto"];
    memberGuid = data["memberGuid"];
    memberName = data["memberName"];
    memberPhoto = data["memberPhoto"];
    sessionGuid = data["sessionGuid"];
    adminName = data["adminName"];
    adminGuid = data["adminGuid"];
  }
}