import 'dart:convert';
import 'package:equatable/equatable.dart';
import 'package:qq_delivery/delivery/model/shared/chat_list_item.dart';



class ChatLatestListResponse extends Equatable{

  List<ChatListItem> items;
  int totalRecords;


  ChatLatestListResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final deliveryLitData = data["items"] as List;

      items=new List<ChatListItem> ();
      deliveryLitData.forEach((element) {
        ChatListItem deliveryListItem = new ChatListItem();
        deliveryListItem.fromMap(element);
        items.add(deliveryListItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}
