import 'dart:convert';
import 'package:equatable/equatable.dart';



class ChatSearchListResponse extends Equatable{

  List<SearchListItem> items;
  int totalRecords;


  ChatSearchListResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final deliveryLitData = data["items"] as List;

      items=new List<SearchListItem> ();
      deliveryLitData.forEach((element) {
        SearchListItem deliveryListItem = new SearchListItem();
        deliveryListItem.fromMap(element);
        items.add(deliveryListItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}

class SearchListItem extends Equatable{

  String guid;
  String name;
  String avatar;
  String type;
  String sessionGuid;

  SearchListItem({this.guid, this.name, this.avatar, this.type, this.sessionGuid});

  @override
  List<Object> get props => [guid, name, avatar, type, sessionGuid];

  @override
  String toString() => this.name;

  fromMap( Map<String, dynamic> data ){
    guid = data["guid"];
    name = data["name"];
    avatar = data["avatar"];
    type = data["type"];
    sessionGuid = data["sessionGuid"];
  }
}