import 'dart:convert';
import 'package:equatable/equatable.dart';



class CODBalanceListResponse extends Equatable{

  List<CashOnDeliveryListItem> items;
  int totalRecords;


  CODBalanceListResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final addressBookListData = data["items"] as List;
      items = new List<CashOnDeliveryListItem>();
      addressBookListData.forEach((element) {
        CashOnDeliveryListItem addressBookItem = new CashOnDeliveryListItem();
        addressBookItem.fromMap(element);
        items.add(addressBookItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}

class CashOnDeliveryListItem extends Equatable{

  String name;
  String guid;
  double transferred;
  double onHand;
  double collected;
  double toCollect;
  double toTransfer;
  double total;
  double transferCount;
  double onHandCount;
  double collectedCount;
  double collectCount;

  CashOnDeliveryListItem({this.name, this.guid, this.transferred,
    this.onHand, this.collected, this.toCollect, this.toTransfer,
    this.total, this.transferCount, this.onHandCount, this.collectedCount, this.collectCount});

  @override
  List<Object> get props => [name, guid, transferred,
    onHand, collected, toCollect, toTransfer,
    total, transferCount, onHandCount, collectedCount, collectCount];

  @override
  String toString() => this.name;

  fromMap( Map<String, dynamic> data ){
    name = data["name"];
    guid = data["guid"];
    transferred = data["transferred"];
    onHand = data["onHand"];
    collected = data["collected"];
    toCollect = data["toCollect"];
    toTransfer = data["toTransfer"];
    total = data["total"];
    transferCount = data["transferCount"];
    onHandCount = data["onHandCount"];
    collectedCount = data["collectedCount"];
    collectCount = data["collectCount"];
  }
}