import 'dart:convert';
import 'package:equatable/equatable.dart';



class DeliveryCountByStatusResponse extends Equatable{

  List<DeliveryCountAndGroupByStatus> items;
  int totalRecords;
  int statusCode;


  DeliveryCountByStatusResponse({this.items, this.totalRecords, this.statusCode});
  @override
  List<Object> get props => [items, totalRecords, statusCode];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      final attendancesData = resultData["data"] as List;
      items = new List<DeliveryCountAndGroupByStatus>();
      attendancesData.forEach((element) {
        DeliveryCountAndGroupByStatus attendanceSearchItem = new DeliveryCountAndGroupByStatus();
        attendanceSearchItem.fromMap(element);
        items.add(attendanceSearchItem);
      });

      totalRecords = 0;
      return true;
    }else{
      return false;
    }
  }
}

class DeliveryCountAndGroupByStatus extends Equatable{

  String status;
  int total;

  DeliveryCountAndGroupByStatus({this.status, this.total});
  @override
  List<Object> get props => [status, total];
  @override
  String toString() => this.status;

  fromMap( Map<String, dynamic> data ){
    status = data["status"];
    total = data["total"];
  }
}