import 'dart:convert';
import 'package:equatable/equatable.dart';



class EmployeeListForDeliveryResponse extends Equatable{

  List<EmployeeForDeliveryItem> items;
  int totalRecords;


  EmployeeListForDeliveryResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final deliveryLitData = data["items"] as List;
      items = new List<EmployeeForDeliveryItem>();
      deliveryLitData.forEach((element) {
        EmployeeForDeliveryItem employeeForDeliveryItem = new EmployeeForDeliveryItem();
        employeeForDeliveryItem.fromMap(element);
        items.add(employeeForDeliveryItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}

class EmployeeForDeliveryItem extends Equatable{

  String name;
  String guid;
  String zoneName;
  String zoneGuid;
  String avatar;
  double latitude;
  double longitude;
  String phone;

  EmployeeForDeliveryItem({this.name, this.guid, this.zoneName,
    this.zoneGuid, this.avatar});
  @override
  List<Object> get props => [name, guid, zoneName, zoneGuid, avatar];
  @override
  String toString() => this.name;

  fromMap( Map<String, dynamic> data ){
    name = data["name"];
    guid = data["guid"];
    zoneName = data["zoneName"];
    zoneGuid = data["zoneGuid"];
    avatar = data["avatar"];
    latitude = data["latitude"];
    longitude = data["longitude"];
    phone = data["phone"];
  }
}