

import 'dart:convert';
import 'package:equatable/equatable.dart';



class FinancialCenterMerchantListResponse extends Equatable{

  List<MerchantAccountingItem> items;
  int totalRecords;

  FinancialCenterMerchantListResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final deliveryLitData = data["items"] as List;
      items = <MerchantAccountingItem>[];
      deliveryLitData.forEach((element) {
        MerchantAccountingItem deliveryListItem = new MerchantAccountingItem();
        deliveryListItem.fromMap(element);
        items.add(deliveryListItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}

class MerchantAccountingItem extends Equatable{

  double payableAmount;
  double receivableAmount;
  double balanceAmount;
  double advanceAmount;
  double payableWayCount;
  double receivableWayCount;
  String name;
  String phone;
  String personId;
  String guid;

  MerchantAccountingItem({this.payableAmount, this.receivableAmount, this.balanceAmount,
    this.advanceAmount, this.payableWayCount, this.receivableWayCount, this.name,
    this.phone, this.personId, this.guid});


  @override
  List<Object> get props => [payableAmount, receivableAmount, balanceAmount,
    advanceAmount, payableWayCount, receivableWayCount, name, phone, personId, guid];

  @override
  String toString() => this.name;

  fromMap( Map<String, dynamic> data ){
    payableAmount = data["payableAmount"];
    receivableAmount = data["receivableAmount"];
    balanceAmount = data["balanceAmount"];
    advanceAmount = data["advanceAmount"];
    payableWayCount = data["payableWayCount"];
    receivableWayCount = data["receivableWayCount"];
    name = data["name"];
    phone = data["phone"];
    personId = data["personId"];
    guid = data["guid"];
  }
}