import 'dart:convert';
import 'package:qq_delivery/delivery/model/shared/general_address_item.dart';
import 'package:equatable/equatable.dart';



class GeneralAddressResponse extends Equatable{

  List<GeneralAddressItem> items;
  int totalRecords;


  GeneralAddressResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final addressBookListData = data["items"] as List;
      items = new List<GeneralAddressItem>();
      addressBookListData.forEach((element) {
        GeneralAddressItem addressBookItem = new GeneralAddressItem();
        addressBookItem.fromMap(element);
        items.add(addressBookItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}