import 'dart:convert';
import 'package:equatable/equatable.dart';



class MemberPromotionResponse extends Equatable{

  List<MemberPromotionItem> items;
  int totalRecords;


  MemberPromotionResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final deliveryLitData = data["items"] as List;
      items = new List<MemberPromotionItem>();
      deliveryLitData.forEach((element) {
        MemberPromotionItem employeeForDeliveryItem = new MemberPromotionItem();
        employeeForDeliveryItem.fromMap(element);
        items.add(employeeForDeliveryItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}

class MemberPromotionItem extends Equatable{

  String name;
  String level;
  DateTime expiredOn;
  double amount;
  double balance;
  DateTime createdOn;
  String guid;

  MemberPromotionItem({this.name, this.level, this.expiredOn, this.amount,
    this.balance, this.createdOn, this.guid});
  @override
  List<Object> get props => [name, level, expiredOn, amount, balance, createdOn, guid];
  @override
  String toString() => this.name;

  fromMap( Map<String, dynamic> data ){
    name = data["name"];
    level = data["level"];
    expiredOn = data["expiredOn"]!=null?DateTime.parse(data["expiredOn"]) : null;
    amount = data["amount"];
    balance = data["balance"];
    createdOn = data["createdOn"]!=null?DateTime.parse(data["createdOn"]) : null;
    guid = data["guid"];
  }
}