import 'dart:convert';
import 'package:equatable/equatable.dart';



class OSBalanceResponse extends Equatable{

  List<OSBalanceItem> items;
  int totalRecords;


  OSBalanceResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final deliveryLitData = data["items"] as List;
      items = new List<OSBalanceItem>();
      deliveryLitData.forEach((element) {
        OSBalanceItem employeeForDeliveryItem = new OSBalanceItem();
        employeeForDeliveryItem.fromMap(element);
        items.add(employeeForDeliveryItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}

class OSBalanceItem extends Equatable{

  String name;
  String guid;
  double deposit;
  double expense;
  double balance;

  OSBalanceItem({this.name, this.guid, this.deposit, this.expense,
    this.balance});
  @override
  List<Object> get props => [name, guid, deposit, expense, balance];
  @override
  String toString() => this.name;

  fromMap( Map<String, dynamic> data ){
    name = data["name"];
    guid = data["guid"];
    deposit = data["deposit"];
    expense = data["expense"];
    balance = data["balance"];
  }
}