import 'dart:convert';
import 'package:equatable/equatable.dart';


class OverdueResponse extends Equatable {
  List<dynamic> labels;
  List<dynamic> delivers;
  List<dynamic>  pickups;
  int overdueDeliver=0;
  int overduePickup=0;

  OverdueResponse({this.labels, this.delivers, this.pickups, this.overdueDeliver, this.overduePickup});
  @override
  List<Object> get props => [labels, delivers, pickups, overdueDeliver, overduePickup];
  @override
  String toString() => this.labels.length.toString();

  Future<bool> fromJson(String json) async{
    if( json == null) return false;

    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      labels = data["labels"] as List;
      delivers = data["data1"] as List;
      pickups = data["data2"] as List;

      for( int i=0; i<delivers.length; i++){
        overdueDeliver = delivers[i] + overdueDeliver;
        overduePickup = pickups[i] + overduePickup;
      }
      return true;
    }else{
      return false;
    }
  }
}