import 'dart:convert';
import 'package:equatable/equatable.dart';



class PersonActiveByRoleResponse extends Equatable{

  List<GeneralPersonItem> items;
  int totalRecords;


  PersonActiveByRoleResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final deliveryLitData = data["items"] as List;
      items = new List<GeneralPersonItem>();
      deliveryLitData.forEach((element) {
        GeneralPersonItem employeeForDeliveryItem = new GeneralPersonItem();
        employeeForDeliveryItem.fromMap(element);
        items.add(employeeForDeliveryItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}

class GeneralPersonItem extends Equatable{

  String personGuid;
  String name;
  String avatar;
  String townshipName;
  String personId;

  GeneralPersonItem({this.personGuid, this.name, this.avatar, this.townshipName, this.personId});
  @override
  List<Object> get props => [personGuid, name, avatar, townshipName, personId];
  @override
  String toString() => this.name;

  fromMap( Map<String, dynamic> data ){
    personGuid = data["personGuid"];
    name = data["name"];
    avatar = data["avatar"];
    townshipName = data["townshipName"];
    personId = data["personId"]??'';
  }
}