import 'dart:convert';
import 'package:equatable/equatable.dart';
import 'package:flutter/material.dart';



class PersonListResponse extends Equatable{

  List<PersonListItem> items;
  int totalRecords;


  PersonListResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final deliveryLitData = data["items"] as List;
      items = new List<PersonListItem>();
      deliveryLitData.forEach((element) {
        PersonListItem employeeForDeliveryItem = new PersonListItem();
        employeeForDeliveryItem.fromMap(element);
        items.add(employeeForDeliveryItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}

class PersonListItem extends Equatable{

  String branchName;
  String branchGuid;
  String supervisorName;
  String supervisorGuid;
  String name;
  String address;
  String mobilePhone;
  String otherPhones;
  String email;
  String status;
  String avatar;
  DateTime updatedOn;
  String guid;
  int addressCount;
  String personId;

  PersonListItem({this.branchName, this.branchGuid, this.supervisorName, this.supervisorGuid,
  this.name, this.address, this.mobilePhone, this.otherPhones, this.email,
  this.status, this.avatar, this.updatedOn, this.guid, this.addressCount, this.personId});
  @override
  List<Object> get props => [this.branchName, this.branchGuid, this.supervisorName, this.supervisorGuid,
    this.name, this.address, this.mobilePhone, this.otherPhones, this.email,
    this.status, this.avatar, this.updatedOn, this.guid, this.addressCount, this.personId];
  @override
  String toString() => this.name;

  fromMap( Map<String, dynamic> data ){
    branchName = data["branchName"];
    branchGuid = data["branchGuid"];
    supervisorName = data["supervisorName"];
    supervisorGuid = data["supervisorGuid"];
    name = data["name"];
    address = data["address"];
    mobilePhone = data["mobilePhone"];
    otherPhones = data["otherPhones"];
    email = data["email"];
    status = data["status"];
    avatar = data["avatar"];
    updatedOn = data["updatedOn"]!=null? DateTime.parse(data["updatedOn"]) : null;
    guid = data['guid'];
    addressCount = data['addressCount'];
    personId = data['personId']??'';
  }
}