import 'dart:convert';
import 'package:equatable/equatable.dart';



class POSCategoryListResponse extends Equatable{

  List<PosCategoryListItem> items;
  int totalRecords;


  POSCategoryListResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final deliveryLitData = data["items"] as List;
      items = new List<PosCategoryListItem>();
      deliveryLitData.forEach((element) {
        PosCategoryListItem posOrderListItem = new PosCategoryListItem();
        posOrderListItem.fromMap(element);
        items.add(posOrderListItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}

class PosCategoryListItem extends Equatable{
  int categoryId;
  String categoryName;
  String displayName;
  DateTime createdOn;
  String guid;

  PosCategoryListItem({this.categoryId, this.categoryName,
    this.displayName, this.createdOn, this.guid});

  @override
  List<Object> get props => [categoryId, categoryName, displayName, createdOn, guid];

  @override
  String toString() => this.categoryName;

  fromMap( Map<String, dynamic> data ){
    categoryId = data["categoryId"];
    categoryName = data["categoryName"];
    displayName = data["displayName"];
    createdOn = data["createdOn"]!=null? DateTime.parse(data["createdOn"]) : null;
    guid = data["guid"];
  }

  Map<String, dynamic> toMap(){
    Map<String, dynamic> data = {
      'id': categoryId,
      'categoryName': categoryName,
      'displayName': displayName,
      'guid':guid
    };
    return data;
  }
}