import 'dart:convert';
import 'package:equatable/equatable.dart';



class POSOrderDetailResponse extends Equatable{

  int orderId;
  DateTime orderDate;
  String orderGuid;
  String buyerName;
  String townshipName;
  String emailAddress;
  String deliveryAddress;
  String contactNo;
  int totalAmount;
  String staffName;
  int staffId;
  List<PosOrderItemInfoForm> items;
  int totalRecords;
  String itemPayment;
  String orderCode;
  DateTime pickUpDate;
  int paidAmount;
  String discountType;
  int discountAmount;
  String pickUpAddress;


  POSOrderDetailResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];
      final deliveryLitData = data["items"] as List;
      items = new List<PosOrderItemInfoForm>();
      deliveryLitData.forEach((element) {
        PosOrderItemInfoForm posOrderListItem = new PosOrderItemInfoForm();
        posOrderListItem.fromMap(element);
        items.add(posOrderListItem);
      });

      orderId = data["orderId"];
      orderDate = data["orderDate"]!=null? DateTime.parse(data["orderDate"]) : null;
      orderGuid = data["orderGuid"];
      buyerName = data["buyerName"];
      townshipName = data["townshipName"];
      emailAddress = data["emailAddress"];
      deliveryAddress = data["deliveryAddress"];
      contactNo = data["contactNo"];
      totalAmount = data["totalAmount"];
      staffName = data["staffName"];
      staffId = data["staffId"];
      totalRecords = data["totalRecords"];
      itemPayment = data["itemPayment"];
      orderCode = data["orderCode"];
      pickUpDate = data["pickUpDate"]!=null? DateTime.parse(data["pickUpDate"]) : null;
      paidAmount = data["paidAmount"];
      discountType = data["discountType"];
      discountAmount = data["discountAmount"];
      pickUpAddress = data["pickUpAddress"];

      return true;
    }else{
      return false;
    }
  }
}

class PosOrderItemInfoForm extends Equatable{

  int id;
  String productCode;
  String displayName;
  int salePrice;
  int quantity;
  int saleAmount;
  int originalPrice;
  int buyingAmount;
  int profit;
  String guid;

  PosOrderItemInfoForm({this.id, this.productCode, this.displayName, this.salePrice,
    this.quantity, this.saleAmount, this.originalPrice, this.buyingAmount,
  this.profit, this.guid});

  @override
  List<Object> get props => [id, productCode, displayName, salePrice,
    quantity, saleAmount, originalPrice, buyingAmount, profit, guid];

  @override
  String toString() => this.displayName;

  fromMap( Map<String, dynamic> data ){
    id = data["id"];
    productCode = data["productCode"];
    displayName = data["displayName"];
    salePrice = data["salePrice"];
    quantity = data["quantity"];
    saleAmount = data["saleAmount"];
    originalPrice = data["originalPrice"];
    buyingAmount = data["buyingAmount"];
    profit = data["profit"];
    guid = data["guid"];
  }
}