import 'dart:convert';
import 'package:equatable/equatable.dart';



class POSPurchaseDetailSummaryResponse extends Equatable{

  List<PurchaseDetailSummaryItem> items;
  int totalRecords;


  POSPurchaseDetailSummaryResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      final deliveryLitData = resultData["data"] as List;
      items = new List<PurchaseDetailSummaryItem>();
      deliveryLitData.forEach((element) {
        PurchaseDetailSummaryItem posOrderListItem = new PurchaseDetailSummaryItem();
        posOrderListItem.fromMap(element);
        items.add(posOrderListItem);
      });
      return true;
    }else{
      return false;
    }
  }
}

class PurchaseDetailSummaryItem extends Equatable{
  String guid;
  DateTime expireOn;
  int quantity;
  int sellQuantity;
  DateTime resultDate;

  PurchaseDetailSummaryItem({this.guid, this.expireOn,
    this.quantity, this.sellQuantity, this.resultDate});

  @override
  List<Object> get props => [guid, expireOn, quantity, sellQuantity, resultDate];

  @override
  String toString() => this.guid;

  fromMap( Map<String, dynamic> data ){
    guid = data["guid"];
    expireOn = data["expireOn"] !=null? DateTime.parse(data["expireOn"]) : null;
    quantity = data["quantity"];
    sellQuantity = data["sellQuantity"];
    resultDate = data["resultDate"] !=null? DateTime.parse(data["resultDate"]) : (data["expireOn"] !=null? DateTime.parse(data["expireOn"]) : null);
  }
}