import 'dart:convert';
import 'package:equatable/equatable.dart';



class POSPurchaseListResponse extends Equatable{

  List<POSPurchaseListItem> items;
  int totalRecords;


  POSPurchaseListResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final deliveryLitData = data["items"] as List;
      items = new List<POSPurchaseListItem>();
      deliveryLitData.forEach((element) {
        POSPurchaseListItem posOrderListItem = new POSPurchaseListItem();
        posOrderListItem.fromMap(element);
        items.add(posOrderListItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}

class POSPurchaseListItem extends Equatable{

  int purchaseId;
  DateTime purchaseDate;
  String purchaseGuid;
  String supplierName;
  int totalProduct;
  int totalQuantity;
  int totalAmount;
  String contactNo;
  String staffName;
  int staffId;

  POSPurchaseListItem({this.purchaseId, this.purchaseDate, this.purchaseGuid,
    this.supplierName, this.totalProduct, this.totalQuantity, this.totalAmount,
    this.contactNo, this.staffName, this.staffId});

  @override
  List<Object> get props => [purchaseId, purchaseDate, purchaseGuid, supplierName,
    totalProduct, totalQuantity, totalAmount, contactNo, staffName, staffId];

  @override
  String toString() => this.supplierName;

  fromMap( Map<String, dynamic> data ){
    purchaseId = data["purchaseId"];
    purchaseDate = data["purchaseDate"]!=null? DateTime.parse(data["purchaseDate"]) : null;
    purchaseGuid = data["purchaseGuid"];
    supplierName = data["supplierName"];
    totalProduct = data["totalProduct"];
    totalQuantity = data["totalQuantity"];
    totalAmount = data["totalAmount"];
    contactNo = data["contactNo"];
    staffName = data["staffName"];
    staffId = data["staffId"];
  }
}