import 'dart:convert';
import 'package:equatable/equatable.dart';



class PurchaseSalesSummaryResponse extends Equatable{

  int purchaseTotalInvoices;
  int purchaseAmount;
  int sellingTotalInvoices;
  int sellingAmount;
  int difference;
  DateTime startedOn;
  DateTime endOn;

  PurchaseSalesSummaryResponse({this.purchaseTotalInvoices, this.purchaseAmount,
  this.sellingTotalInvoices, this.sellingAmount, this.difference, this.startedOn,
    this.endOn});
  @override
  List<Object> get props => [purchaseTotalInvoices, purchaseAmount,
    sellingTotalInvoices, sellingAmount, difference, startedOn, endOn];
  @override
  String toString() => 'Summary= ${this.difference}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];
      purchaseTotalInvoices = data["purchaseTotalInvoices"];
      purchaseAmount = data["purchaseAmount"];
      sellingTotalInvoices = data["sellingTotalInvoices"];
      sellingAmount = data["sellingAmount"];
      difference = data["difference"];
      startedOn = data["startedOn"]!=null? DateTime.parse(data["startedOn"]) : null;
      endOn = data["endOn"]!=null? DateTime.parse(data["endOn"]) : null;

      return true;
    }else{
      return false;
    }
  }
}