import 'dart:convert';
import 'package:equatable/equatable.dart';



class POSOrderListResponseV3 extends Equatable{

  List<POSOrderListItemV3> items;
  int totalRecords;


  POSOrderListResponseV3({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final deliveryLitData = data["items"] as List;
      items = new List<POSOrderListItemV3>();
      deliveryLitData.forEach((element) {
        POSOrderListItemV3 posOrderListItem = new POSOrderListItemV3();
        posOrderListItem.fromMap(element);
        items.add(posOrderListItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}

class POSOrderListItemV3 extends Equatable{

  String sellerName;
  String sellerGuid;
  String buyerName;
  String buyerGuid;
  String primaryPhone;
  String otherPhones;
  String email;
  String address;
  String street;
  String townshipName;
  String townshipGuid;
  double totalAmount;
  double paidAmount;
  double discountAmount;
  String discountType;
  String status;
  String shipment;
  String remark;
  String guid;
  int totalQuantity;
  double originalPriceTotal;
  String deliveryWayMessage;
  DateTime createdOn;
  DateTime updatedOn;
  int createdBy;
  String createdByName;
  int updatedBy;
  String updatedByName;
  String salesId;
  bool validPayment;
  String businessName;
  String businessPhone;
  String businessGuid;
  String dropOffPersonName;
  String dropOffPersonGUID;
  DateTime dropOffDate;
  String deliveryStatus;
  String trackingId;
  double totalDeliveryCharges;
  double forShowCharges;
  double transactionAmount;

  POSOrderListItemV3({this.sellerName, this.sellerGuid, this.buyerName, this.buyerGuid,
    this.primaryPhone, this.otherPhones, this.email, this.address,
  this.street, this.townshipName, this.townshipGuid, this.totalAmount, this.paidAmount,
  this.discountAmount, this.discountType, this.status, this.shipment, this.remark,
  this.guid, this.totalQuantity, this.originalPriceTotal, this.deliveryWayMessage,
  this.createdOn, this.updatedOn, this.createdBy, this.createdByName, this.updatedBy,
  this.updatedByName, this.salesId, this.validPayment, this.businessName, this.businessPhone,
  this.businessGuid, this.dropOffPersonName, this.dropOffPersonGUID, this.dropOffDate,
  this.deliveryStatus, this.trackingId, this.totalDeliveryCharges, this.forShowCharges,
  this.transactionAmount});

  @override
  List<Object> get props => [sellerName, sellerGuid, buyerName, buyerGuid,
    primaryPhone, otherPhones, email, address,
    street, townshipName, townshipGuid, totalAmount, paidAmount,
    discountAmount, discountType, status, shipment, remark,
    guid, totalQuantity, originalPriceTotal, deliveryWayMessage,
    createdOn, updatedOn, createdBy, createdByName, updatedBy,
    updatedByName, salesId, validPayment, businessName, businessPhone,
    businessGuid, dropOffPersonName, dropOffPersonGUID, dropOffDate,
    deliveryStatus, trackingId, totalDeliveryCharges, forShowCharges, transactionAmount];

  @override
  String toString() => this.buyerName;

  fromMap( Map<String, dynamic> data ){
    sellerName = data["sellerName"];
    sellerGuid = data["sellerGuid"];
    buyerName = data["buyerName"];
    buyerGuid = data["buyerGuid"];
    primaryPhone = data["primaryPhone"];
    otherPhones = data["otherPhones"];
    email = data["email"];
    address = data["address"];
    street = data["street"];
    townshipName = data["townshipName"];
    townshipGuid = data["townshipGuid"];
    totalAmount = data["totalAmount"];
    paidAmount = data["paidAmount"];
    discountAmount = data["discountAmount"];
    discountType = data["discountType"];
    status = data["status"];
    shipment = data["shipment"];
    remark = data["remark"];
    guid = data["guid"];
    totalQuantity = data["totalQuantity"];
    originalPriceTotal = data["originalPriceTotal"];
    deliveryWayMessage = data["deliveryWayMessage"];
    createdOn = data["createdOn"]!=null? DateTime.parse(data["createdOn"]) : null;
    updatedOn = data["updatedOn"]!=null? DateTime.parse(data["updatedOn"]) : null;
    createdBy = data["createdBy"];
    createdByName = data["createdByName"];
    updatedBy = data["updatedBy"];
    updatedByName = data["updatedByName"];
    salesId = data["salesId"];
    validPayment = data["validPayment"]??false;
    businessName = data["businessName"];
    businessPhone = data["businessPhone"];
    businessGuid = data["businessGuid"];
    dropOffPersonName = data["dropOffPersonName"];
    dropOffPersonGUID = data["dropOffPersonGUID"];
    dropOffDate = data["dropOffDate"]!=null? DateTime.parse(data["dropOffDate"]) : null;
    deliveryStatus = data["deliveryStatus"];
    trackingId = data["trackingId"];
    totalDeliveryCharges = data["totalDeliveryCharges"];
    forShowCharges = data["forShowCharges"];
    transactionAmount = data["transactionAmount"];
  }
}