import 'dart:convert';
import 'package:equatable/equatable.dart';



class PurchaseItemDetailListResponseV3 extends Equatable{

  List<PurchaseDetailItemListItem> items;
  int totalRecords;


  PurchaseItemDetailListResponseV3({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final deliveryLitData = data["items"] as List;
      items = new List<PurchaseDetailItemListItem>();
      deliveryLitData.forEach((element) {
        PurchaseDetailItemListItem posOrderListItem = new PurchaseDetailItemListItem();
        posOrderListItem.fromMap(element);
        items.add(posOrderListItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}

class PurchaseDetailItemListItem extends Equatable{

  String purchaseDetailGuid;
  String status;
  String description;
  String note;
  String photo;
  String guid;
  DateTime createdOn;
  DateTime updatedOn;
  DateTime expireOn;
  DateTime resultDate;

  PurchaseDetailItemListItem({this.purchaseDetailGuid, this.status, this.description, this.note,
    this.photo, this.guid, this.createdOn, this.updatedOn, this.expireOn, this.resultDate});

  @override
  List<Object> get props => [purchaseDetailGuid, status, description, note,
    photo, guid, createdOn, updatedOn, expireOn, resultDate];

  @override
  String toString() => this.description;

  fromMap( Map<String, dynamic> data ){
    purchaseDetailGuid = data["purchaseDetailGuid"];
    status = data["status"];
    description = data["description"];
    note = data["note"];
    photo = data["photo"];
    guid = data["guid"];
    createdOn = data["createdOn"]!=null? DateTime.parse(data["createdOn"]) : null;
    updatedOn = data["updatedOn"]!=null? DateTime.parse(data["updatedOn"]) : null;
    expireOn = data["expireOn"]!=null? DateTime.parse(data["expireOn"]) : null;
    resultDate = data["resultDate"]!=null? DateTime.parse(data["resultDate"]) : null;
  }
}