import 'dart:convert';
import 'package:equatable/equatable.dart';


class PriceListResponse extends Equatable{

  List<PriceListItem> items;
  int totalRecords;

  PriceListResponse({this.items, this.totalRecords});

  @override
  List<Object> get props => [items, totalRecords];

  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final deliveryLitData = data["items"] as List;
      items = new List<PriceListItem>();
      deliveryLitData.forEach((element) {
        PriceListItem employeeForDeliveryItem = new PriceListItem();
        employeeForDeliveryItem.fromMap(element);
        items.add(employeeForDeliveryItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}

class PriceListItem extends Equatable{

  String name;
  double basedPrice;
  double extraFragile;
  int maximumDimension;
  int maximumWeight;
  String description;
  DateTime updatedOn;
  String townships;
  String destinationTownships;
  bool differentDestination;
  bool showAll;


  PriceListItem({this.name, this.basedPrice, this.extraFragile,
    this.maximumDimension, this.maximumWeight, this.description, this.updatedOn,
    this.townships, this.destinationTownships, this.differentDestination, this.showAll});

  @override
  List<Object> get props => [name, basedPrice, extraFragile, maximumDimension,
    maximumWeight, description, updatedOn, townships, destinationTownships,
    differentDestination, showAll];

  @override
  String toString() => this.name;

  fromMap( Map<String, dynamic> data ){
    name = data["name"];
    basedPrice = data["basedPrice"];
    extraFragile = data["extraFragile"];
    maximumDimension = data["maximumDimension"];
    maximumWeight = data["maximumWeight"];
    description = data["description"];
    updatedOn = data["updatedOn"]!=null? DateTime.parse(data["updatedOn"]) : null;
    townships = data["townships"];
    destinationTownships = data["destinationTownships"];
    differentDestination = data["differentDestination"];
    showAll = false;
  }
}