import 'dart:convert';
import 'package:equatable/equatable.dart';



class ZoneListResponse extends Equatable{

  List<ZoneItem> items;
  int totalRecords;


  ZoneListResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final deliveryLitData = data["items"] as List;
      items = new List<ZoneItem>();
      deliveryLitData.forEach((element) {
        ZoneItem employeeForDeliveryItem = new ZoneItem();
        employeeForDeliveryItem.fromMap(element);
        items.add(employeeForDeliveryItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }
}

class ZoneItem extends Equatable{

  String branchGuid;
  String name;
  String prefix;
  bool active;
  DateTime updatedOn;
  String guid;
  int employeeCount;
  int townshipCount;

  ZoneItem({this.branchGuid, this.name, this.prefix, this.active,
    this.updatedOn, this.guid, this.employeeCount, this.townshipCount});
  @override
  List<Object> get props => [branchGuid, name, prefix, active,
    updatedOn, guid, employeeCount, townshipCount];
  @override
  String toString() => this.name;

  fromMap( Map<String, dynamic> data ){
    branchGuid = data["branchGuid"];
    name = data["name"];
    prefix = data["prefix"];
    active = data["active"];
    updatedOn = data["updatedOn"]!=null? DateTime.parse(data["updatedOn"]) : null;
    guid = data["guid"];
    employeeCount = data["employeeCount"];
    townshipCount = data["townshipCount"];
  }
}