

import 'package:equatable/equatable.dart';

class ChatListItem extends Equatable{

  static const String MEDIA_TYPE_TEXT = "Text";
  static const String MEDIA_TYPE_FILE = "File";
  static const String MEDIA_TYPE_IMAGE = "Image";
  static const String MEDIA_TYPE_VOICE = "Voice";

  String messageContent;
  String attachFile;
  String sessionType;
  String sender;
  String receiver;
  String owner;
  DateTime createOn;
  String sessionGuid;
  String sendStatus;
  String mediaType;
  String senderGuid;
  String receiverGuid;
  String ownerGuid;
  String senderPhoto;
  String receiverPhoto;
  String ownerPhoto;

  ChatListItem({this.messageContent, this.attachFile, this.sessionType,
    this.sender, this.receiver, this.owner, this.createOn,
    this.sessionGuid, this.sendStatus, this.mediaType, this.senderGuid, this.receiverGuid,
    this.ownerGuid, this.senderPhoto, this.receiverPhoto, this.ownerPhoto});

  @override
  List<Object> get props => [messageContent, attachFile, sessionType,
    sender, receiver, owner, createOn, sessionGuid, sendStatus, mediaType,
    senderGuid, receiverGuid, ownerGuid, senderPhoto, receiverPhoto, ownerPhoto];

  @override
  String toString() => this.messageContent;

  fromMap( Map<String, dynamic> data ){
    messageContent = data["messageContent"];
    attachFile = data["attachFile"];
    sessionType = data["sessionType"];
    sender = data["sender"];
    receiver = data["receiver"];
    owner = data["owner"];
    createOn = data["createOn"]!=null?DateTime.parse(data["createOn"]) : null;
    sessionGuid = data["sessionGuid"];
    sendStatus = data["sendStatus"];
    mediaType = data["mediaType"];
    senderGuid = data["senderGuid"];
    receiverGuid = data["receiverGuid"];
    ownerGuid = data["ownerGuid"];
    senderPhoto = data["senderPhoto"];
    receiverPhoto = data["receiverPhoto"];
    ownerPhoto = data["ownerPhoto"];
  }
}