
import 'package:equatable/equatable.dart';
import 'package:intl/intl.dart';


class DeliveryContactItem extends Equatable{

  String personGuid;
  String name;
  DateTime date;
  String address;
  String street;
  String ward;
  String township;
  String townshipGuid;
  String primaryPhone;
  String otherPhones;
  String email;
  String comment;
  double latitude;
  double longitude;
  String contactType;//Pickup, Dropoff, Pickup Employee, Drop-off Employee
  String guid;
  String avatar;
  String addressType;
  String stateGuid;
  String signature;

  DeliveryContactItem({this.personGuid, this.name, this.date, this.address,
    this.street, this.ward, this.township, this.townshipGuid, this.primaryPhone,
    this.otherPhones, this.email, this.comment, this.latitude, this.longitude,
    this.contactType, this.guid, this.avatar, this.addressType, this.stateGuid,
  this.signature});

  @override
  List<Object> get props => [personGuid, name, date, address, street, ward,
    township, townshipGuid, primaryPhone, otherPhones, email, comment, latitude,
    longitude, contactType, guid, avatar, addressType, stateGuid, signature];

  @override
  String toString() => this.name;

  fromMap( Map<String, dynamic> data ){
    if( data == null )return;

    personGuid = data["personGuid"];
    name = data["name"];
    date = data["date"]!=null?DateTime.parse(data["date"]) : null;
    address = data["address"];
    street = data["street"];
    ward = data["ward"];
    township = data["township"];
    townshipGuid = data["townshipGuid"];
    primaryPhone = data["primaryPhone"];
    otherPhones = data["otherPhones"];
    email = data["email"];
    comment = data["comment"];
    latitude = data["latitude"];
    longitude = data["longitude"];
    contactType = data["contactType"];
    guid = data["guid"];
    avatar = data["avatar"];
    addressType = data["addressType"];
    stateGuid = data["stateGuid"];
    signature = data["signature"];
  }

  Map<String, dynamic> toMap(){
    Map<String, dynamic> data = {
      'personGuid': personGuid,
      'name': name,
      'date': date!=null? new DateFormat('yyyy-MM-dd').format(date) : null,
      'address': address,
      'street': street,
      'ward': ward,
      'township': township,
      'townshipGuid': townshipGuid,
      'primaryPhone': primaryPhone,
      'otherPhones': otherPhones,
      'email': email,
      'comment': comment,
      'latitude': latitude,
      'longitude': longitude,
      'contactType': contactType,
      'guid': guid,
      'avatar': avatar,
      'addressType': addressType,
    };
    return data;
  }
}