
import 'package:equatable/equatable.dart';



class DeliveryItem extends Equatable{

  String name;
  double weight;
  double width;
  double height;
  double length;
  bool fragile;
  bool insurance;
  double price;
  double charges;
  String priceOption;//Paid, Unpaid
  String chargeOption;//Paid, Unpaid
  String description;
  String image;
  String reference;
  String guid;
  double forShowCharges;

  DeliveryItem({this.name, this.weight, this.width, this.height, this.length,
  this.fragile, this.insurance, this.price, this.charges, this.priceOption,
  this.chargeOption, this.description, this.image, this.reference, this.guid, this.forShowCharges});

  @override
  List<Object> get props => [name, weight, width, height, length,
    fragile, insurance, price, charges, priceOption,
    chargeOption, description, image, reference, guid];

  @override
  String toString() => this.name;

  fromMap( Map<String, dynamic> data ){
    name = data["name"];
    weight = data["weight"];
    width = data["width"];
    height = data["height"];
    length = data["length"];
    fragile = data["fragile"];
    insurance = data["insurance"];
    price = data["price"];
    charges = data["charges"];
    priceOption = data["priceOption"];
    chargeOption = data["chargeOption"];
    description = data["description"];
    image = data["image"];
    reference = data["reference"];
    guid = data["guid"];
    forShowCharges = data["forShowCharges"]??data["charges"];
  }

  Map<String, dynamic> toMap(){
    Map<String, dynamic> data = {
      'name': name,
      'weight': weight,
      'width': width,
      'height': height,
      'length': length,
      'fragile': fragile,
      'insurance': insurance,
      'price': price,
      'charges': charges,
      'priceOption': priceOption,
      'chargeOption': chargeOption,
      'description': description,
      'image': image,
      'reference': reference,
      'guid': guid,
      'forShowCharges': forShowCharges,
    };
    return data;
  }
}