import 'dart:convert';
import 'package:qq_delivery/delivery/config/constant.dart';
import 'package:qq_delivery/delivery/model/request/employee_clearance_list_request.dart';
import 'package:qq_delivery/delivery/model/request/person_list_request.dart';
import 'package:qq_delivery/delivery/model/response/cod_balance_list_response.dart';
import 'package:qq_delivery/delivery/model/response/employee_clearance_list_response.dart';
import 'package:qq_delivery/delivery/model/response/http_response.dart';
import 'package:qq_delivery/delivery/model/response/os_balance_response.dart';
import 'package:qq_delivery/delivery/model/response/person_active_person_by_role_response.dart';
import 'package:qq_delivery/delivery/model/response/person_list_response.dart';
import 'hrm_base_client.dart';
import 'user_service.dart';



class EmployeeCollectedService{

  String _uri = "/v3/employee_collected/";

  Future<EmployeeClearanceListResponse> listEmployeeClearance( EmpployeeClearanceListRequest request ) async{
    EmployeeClearanceListResponse response;

    UserService _userService = UserService();
    String accessToken = await _userService.getToken();
    HTTPResponse httpResponse = await postRequestWithAccessToken(
        "${_uri}list",
        request.toMap(),
        accessToken );
    if( Constant.ENABLE_LOGS)
      print(httpResponse.data);

    response = new EmployeeClearanceListResponse();
    if( !response.fromJson(httpResponse.data))return null;
    
    return response;
  }

  Future<String> clear( Map<String, dynamic> request ) async{
    UserService _userService = UserService();
    String accessToken = await _userService.getToken();
    HTTPResponse httpResponse = await postRequestWithAccessToken(
        "${_uri}clear",
        request,
        accessToken );
    if( Constant.ENABLE_LOGS)
      print(httpResponse.data);
    return httpResponse.data;
  }

  Future<CODBalanceListResponse> fetchCashOnDelivery( EmpployeeClearanceListRequest request ) async{
    CODBalanceListResponse response;

    UserService _userService = UserService();
    String accessToken = await _userService.getToken();
    HTTPResponse httpResponse = await postRequestWithAccessToken(
        "${_uri}cash_on_delivery",
        request.toMap(),
        accessToken );
    if( Constant.ENABLE_LOGS)
      print(httpResponse.data);

    response = new CODBalanceListResponse();
    response.fromJson(httpResponse.data);
    return response;
  }
}