import 'dart:convert';
import 'package:qq_delivery/delivery/config/constant.dart';
import 'package:qq_delivery/delivery/model/response/http_response.dart';
import 'package:qq_delivery/delivery/model/response/price_list_response.dart';
import 'package:qq_delivery/delivery/model/shared/delivery_item.dart';
import 'hrm_base_client.dart';
import 'user_service.dart';


class PriceMethodService{

  String _url = "/v3/price/";
  UserService _userService = new UserService( );

  Future<Map<String, dynamic>> calculatePrice( DeliveryItem request,
      String townshipGuid, String pickupTownshipGuid, String lang,
      String dropOffBookGuid, String pickupBookGuid, String personGuid, [String packageType="Regular"] ) async{

    String accessToken = await _userService.getToken();
    HTTPResponse httpResponse = await postRequestWithAccessToken(
        "${_url}calculate_price/$townshipGuid?pickupTownshipGuid=$pickupTownshipGuid&lang=$lang&dropOffBookGuid=$dropOffBookGuid&pickupBookGuid=$pickupBookGuid&personGuid=$personGuid&packageType=$packageType",
        request.toMap(),
        accessToken
    );
    if( Constant.ENABLE_LOGS)
      print(httpResponse.data);

    Map<String, dynamic> resultData = jsonDecode(httpResponse.data);
    return resultData;
  }

  Future<PriceListResponse> priceList( String lang) async{
    PriceListResponse priceListResponse = new PriceListResponse();
    String jsonString = await getRequest("${_url}list_for_mobile?lang=$lang");
    if( Constant.ENABLE_LOGS)
      print( jsonString );

    if( !priceListResponse.fromJson(jsonString) )
      priceListResponse = null;

    return priceListResponse;
  }

}