import 'dart:convert';
import 'package:qq_delivery/delivery/config/constant.dart';
import 'package:qq_delivery/delivery/service/hrm_base_client.dart';
import 'user_service.dart';


class SettingsService{
  String _uri = "/v3/settings/";

  Future<Map<String, dynamic>> codeVersion() async{
    String jsonString = await getRequest("${_uri}code_version" );

    if( Constant.ENABLE_LOGS)
      print(jsonString);

    Map<String, dynamic> resultData = jsonDecode(jsonString);
    return resultData;
  }

  Future<bool> localSetting( String merchantGuid ) async{
    bool response = false;
    UserService _userService = UserService();
    String accessToken = await _userService.getToken();

    String jsonString = await getRequestWithAccessToken( "${_uri}local_setting/allow_pos?merchantGuid=$merchantGuid", accessToken );
    if( Constant.ENABLE_LOGS)
      print(jsonString);

    Map<String, dynamic> resultData = jsonDecode(jsonString);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];
      response = data['value']=='true';
    }
    return response;
  }

}