import 'dart:convert';

import 'package:qq_delivery/delivery/config/constant.dart';
import 'package:qq_delivery/delivery/model/response/comment_list_response.dart';
import 'package:qq_delivery/delivery/model/response/http_response.dart';
import '../hrm_base_client.dart';
import '../user_service.dart';


class CommentService{
  String _url = "/v3/comment/";

  Future<CommentListResponse> list(String accessToken, String type, String referenceGuid, int first, int max) async{
    CommentListResponse response;

    String jsonString = await getRequestWithAccessToken(
        "${_url}list?type=$type&referenceGuid=$referenceGuid&first=$first&max=$max", accessToken );

    if( Constant.ENABLE_LOGS)
      print(jsonString);

    response = new CommentListResponse();
    response.fromJson(jsonString);
    return response;
  }

  Future<Map<String, dynamic>> create(Map<String, dynamic> request ) async{

    UserService _userService = UserService();
    String accessToken = await _userService.getToken( );
    HTTPResponse httpResponse = await postRequestWithAccessToken(
        "${_url}create",
        request,
        accessToken );
    if( Constant.ENABLE_LOGS)
      print(httpResponse.data);

    Map<String, dynamic> resultData = jsonDecode(httpResponse.data);
    return resultData;
  }
}