

import 'package:qq_delivery/delivery/config/constant.dart';
import 'package:qq_delivery/delivery/model/request/delivery_list_request.dart';
import 'package:qq_delivery/delivery/model/response/financial_center_merchant_list_response.dart';
import 'package:qq_delivery/delivery/model/response/http_response.dart';
import '../hrm_base_client.dart';
import '../user_service.dart';


class FinancialCeterServiceV2{

  String _url = "/v3/financial_center/";
  UserService _userService = new UserService();

  Future<FinancialCenterMerchantListResponse> merchantList(String accessToken,
      DeliveryListRequest request ) async{
    FinancialCenterMerchantListResponse response;

    HTTPResponse httpResponse = await postRequestWithAccessToken(
        "${_url}list_merchant",
        request.toMap(),
        accessToken );
    if( Constant.ENABLE_LOGS)
      print(httpResponse.data);

    response = new FinancialCenterMerchantListResponse();
    response.fromJson(httpResponse.data);
    return response;
  }

}