
import 'package:qq_delivery/delivery/config/constant.dart';
import 'package:qq_delivery/delivery/model/response/active_printer_response.dart';
import '../hrm_base_client.dart';
import '../user_service.dart';


class RemotePrinterService{

  String _url = "/v3/remote_printer/";
  UserService _userService = new UserService();

  Future<ActivePrinterResponse> list( ) async{
    ActivePrinterResponse response;

    String accessToken = await _userService.getToken();
    String jsonString = await getRequestWithAccessToken(
        "${_url}list", accessToken );

    if( Constant.ENABLE_LOGS)
      print( jsonString );

    response = new ActivePrinterResponse();
    response.fromJson(jsonString);
    return response;
  }

  Future<String> queueCreate(String printerGuid, String fileGuid ) async{
    String accessToken = await _userService.getToken();
    String jsonString = await getRequestWithAccessToken(
        "${_url}create/$printerGuid/$fileGuid", accessToken );
    if( Constant.ENABLE_LOGS)
      print( jsonString );
    return jsonString;
  }

}