

import 'package:qq_delivery/delivery/config/constant.dart';
import 'package:qq_delivery/delivery/model/response/route_list_by_navigation_response.dart';
import '../hrm_base_client.dart';
import '../user_service.dart';

class RouteNavigationService{

  String _url = "/v3/navigation/";

  Future<RouteListByNavigationResponse> navigate(
      double sourceLat, double sourceLon,
      double targetLat, double targetLon, [String profile=''] ) async{
    RouteListByNavigationResponse response;
    UserService _userService = UserService();
    String accessToken = await _userService.getToken();

    String jsonString = await getRequestWithAccessToken( "${_url}navigate?sourceLat=$sourceLat&sourceLon=$sourceLon&targetLat=$targetLat&targetLon=$targetLon&profile=$profile", accessToken );
    if( Constant.ENABLE_LOGS)
      print(jsonString);

    response = new RouteListByNavigationResponse();
    response.fromJson(jsonString);
    return response;
  }

}