
import 'dart:io';
import 'dart:convert';
import 'package:flutter/material.dart';
import 'dart:typed_data';
import 'package:http/http.dart' as http;


//https://www.coderzheaven.com/2019/10/15/googles-flutter-tutorial-save-image-as-string-in-local-storage-and-retrieve-preferences/
String encode( File file){
  return base64Encode(file.readAsBytesSync());
}

Image decode( String base64String ){
  return Image.memory(
    base64Decode(base64String),
    fit: BoxFit.fill,
  );
}

String base64String(Uint8List data) {
  return base64Encode(data);
}

Future<String> networkImageToBase64(String imageUrl) async {
  http.Response response = await http.get( Uri.parse(imageUrl) );
  final bytes = response?.bodyBytes;
  return (bytes != null ? base64Encode(bytes) : null);
}

Future<List<int>> networkImageToBytes(String imageUrl) async {
  http.Response response = await http.get( Uri.parse(imageUrl) );
  final bytes = response?.bodyBytes;
  return (bytes != null ? bytes : null);
}