import 'dart:io';
import 'package:qq_delivery/delivery/config/constant.dart';
import 'package:qq_delivery/delivery/utils/base64image.dart';
import 'package:flutter/material.dart';
import 'package:flutter_image_compress/flutter_image_compress.dart';
import 'package:image_picker/image_picker.dart';
import 'package:image/image.dart' as imglib;
import 'package:path_provider/path_provider.dart';
import 'package:shared_preferences/shared_preferences.dart';



class EditPhotos extends StatefulWidget {
  EditPhotos({Key key, this.onDispose, this.onChanged, this.onCompleted,
    this.avatar, this.sharedPrefs}) : super(key: key);
  final Function onDispose;
  final Function onChanged;
  final Function onCompleted;
  final String avatar;
  final SharedPreferences sharedPrefs;

  @override
  _EditPhotosState createState() => _EditPhotosState( );

}

class _EditPhotosState extends State<EditPhotos>{
  bool _processing = false;
  int _selectedPhoto = 0;
  // List<String> _photoLabel = ["Profile image","Face 1","Face 2","Face 3"];
  String _image = 'no';

  @override
  initState() {
    super.initState( );
      _image = 'no';
    setState(() {});
  }

  @override
  Widget build(BuildContext context) {
    return new Container(
        padding: const EdgeInsets.only(left: 10.0, top: 10.0, right: 10.0),
        child:Card(
          // color: Colors.grey[50],
          elevation: 1,
          child: Container(
            padding: const EdgeInsets.only(left: 10.0, top: 10.0, right: 10.0),
            child:new Column(
              crossAxisAlignment: CrossAxisAlignment.center,
              children: <Widget>[
                Container(
                  margin: const EdgeInsets.only(left: 5.0, right: 5.0),
                  child: _image != 'no' ?
                      Container(
                    padding: const EdgeInsets.all(5.0),
                    child: ClipOval(
                        child: Material(
                          elevation: 8,
                          // color: Colors.white, // button color
                          child: InkWell(
                            // splashColor: Colors.red, // inkwell color
                            child: SizedBox(width: 150,
                                height: 150,
                                child: decode( _image )
                            ),
                          ),
                        )
                    ),
                  ) : ClipOval(
                      child: Material(
                        elevation: 2,
                        color: Colors.white, // button color
                        child: InkWell(
                          // splashColor: Colors.red, // inkwell color
                          child: SizedBox(
                            width: 150,
                            height: 150,
                            child: widget.avatar!=null && widget.avatar.length>10?
                            new Image.network( '${getBaseURL(widget.sharedPrefs)}${Constant.IMAGE_DOWNLOAD_BASE_URL}${widget.avatar}', width: 130, height: 130, scale: 0.5,)
                                : Icon(Icons.account_circle, size: 120,),
                          ),
                        ),
                      )
                  ),
                ),
                Container(
                  margin: const EdgeInsets.only(left: 0.0, right: 0.0, bottom: 16),
                  child:Text(
                    "Profile image",
                    style: new TextStyle(fontSize: 12.0),
                  ),
                ),
                // _photoSelection(),
                Container(
                  margin: const EdgeInsets.only(top: 0.0, bottom: 5.0),
                  child: Wrap(
                    spacing: 20,
                    runSpacing: 20,
                    //mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                    children: [
                      _buildButtonColumn( Theme.of(context).primaryColor, Icons.photo_camera, 'Take photo'),
                      _buildButtonColumn( null, Icons.photo_library, 'Browse'),
                      //_images[_selectedPhoto] == 'no'
                      //? Container() :
                      _buildButtonColumn(_image == 'no' ? Colors.grey[100] : Theme.of(context).primaryColor, Icons.delete_forever, 'Remove'),
                    ],
                  ),
                ),

                Container(
                  margin: const EdgeInsets.only(top: 15.0, bottom: 15.0),
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                    children: [
                      _buildButtons( Theme.of(context).primaryColor, Icons.save, 'Save' ),
                      _buildButtons( null, Icons.cancel, 'Cancel'),
                    ],
                  ),
                )
              ]
            )
          )
        )
      );
  }

  Widget _photoSelection( ){
    return Container(
      margin: const EdgeInsets.only(top: 0.0, left: 0.0),
      child:new Row(
        mainAxisAlignment: MainAxisAlignment.center,
        children: <Widget>[
          new Radio(
            value: 0,
            groupValue: _selectedPhoto,
            onChanged: ( value){
              setState(() { _selectedPhoto = value; });
            },
          ),
          new Text(
            'Profile',
            style: new TextStyle(fontSize: 16.0),
          ),
          new Radio(
            value: 1,
            groupValue: _selectedPhoto,
            onChanged: ( value){
              setState(() { _selectedPhoto = value;});
            },
          ),
          new Text(
            '1',
            style: new TextStyle(
              fontSize: 16.0,
            ),
          ),new Radio(
            value: 2,
            groupValue: _selectedPhoto,
            onChanged: ( value){
              setState(() { _selectedPhoto = value;});
            },
          ),
          new Text(
            '2',
            style: new TextStyle(fontSize: 16.0),
          ),
          new Radio(
            value: 3,
            groupValue: _selectedPhoto,
            onChanged: ( value){
              setState(() { _selectedPhoto = value;});
            },
          ),
          new Text(
            '3',
            style: new TextStyle(
              fontSize: 16.0,
            ),
          ),
        ],
      ),
    );
  }

  Column _buildButtonColumn(Color color, IconData icon, String label) {
    return Column(
      mainAxisSize: MainAxisSize.min,
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        ClipOval(
            child: Material(
              color: color, // button color
              child: InkWell(
                splashColor: Colors.red, // inkwell color
                child: SizedBox(width: 36,
                    height: 36,
                    child: Icon(icon, color: Colors.white)
                ),
                onTap:_processing?null : ()async{
                  if( label == 'Take photo'){
                    await _getImage(true);
                  }else if( label == 'Browse'){
                    await _getImage(false);
                  }else if( label == 'Remove'){
                    setState(() {
                      _image = 'no';
                    });
                  }
                },
              ),
            )
        ),
        Container(
          margin: const EdgeInsets.only(top: 5),
          child: Text(
            label,
            style: TextStyle(
                fontSize: 14,
                fontWeight: FontWeight.w400,
                color: color
            ),
          ),
        ),
      ],
    );
  }
  Future<void> _getImage( bool isCamera) async {
    _processing = true;
    widget.onChanged();

    try{
      final picker = ImagePicker();
      final image = await picker.getImage(source: isCamera? ImageSource.camera : ImageSource.gallery);
      if( image != null ) {
        final Directory extDir = await getApplicationDocumentsDirectory();
        final String tmpDir = '${extDir.path}/Pictures/flutter_test';
        await Directory(tmpDir).create(recursive: true);

        if( _selectedPhoto == 0 ){
          await _addImage(tmpDir, image.path);
        }
      }
    }catch(e){widget.onCompleted('Error occur, please select another photo');print(e);}
    _processing = false;
    widget.onCompleted('OK');
  }

  Future<void> _addImage(String tmpDir, String path) async{
    String photoPath2 = '$tmpDir/${DateTime.now()}-2.jpg';
    File rotatedFile = await FlutterImageCompress.compressAndGetFile(
      path, photoPath2,
      quality: 90,
      rotate: 0,
    );
    imglib.Image thumbnail = imglib.copyResize( imglib.decodeImage( rotatedFile.readAsBytesSync()), width: 192);
    String cropFilePath = '$tmpDir/cropped.jpg';
    File(cropFilePath)
      ..writeAsBytesSync(imglib.encodeJpg(thumbnail, quality: 90));

    File smallFile  =File(cropFilePath);
    String encodedString = encode( smallFile );
    smallFile.deleteSync(recursive: false);
    rotatedFile.deleteSync(recursive: false);
    setState(() {_image = encodedString;});
  }

  Column _buildButtons(Color color, IconData icon, String label) {
    return Column(
      mainAxisSize: MainAxisSize.min,
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        RaisedButton.icon(
          elevation: 2.0,
          icon: Icon(icon, color: Colors.white),
          color: color,
          onPressed:_processing ? null: () async{
            if( label == 'Cancel'){
              widget.onDispose( _image, false);
            }else{
              widget.onDispose( _image, true);
            }
          },
          label: Text(
            label,
            style: TextStyle(
              fontSize: 16,
              fontWeight: FontWeight.w400,
              color: Colors.white,
            ),
          ),
        ),
      ],
    );
  }
}