import 'dart:async';

import 'package:flutter/material.dart';
import 'package:url_launcher/url_launcher.dart';


class Advertising extends StatefulWidget {
  Advertising({Key key}) : super(key: key);

  @override
  _AdvertisingState createState() => _AdvertisingState();
}

class _AdvertisingState extends State<Advertising> {

  bool isStopped = false;
  List _ads;

  int currentIndex = 0;

  @override
  void initState() {

    _ads = [
      // {"img":"ad_1.jpg", "url":"http://www.retrofitnessclub.com"},
      {"img":"ad_2.jpg", "url":"http://www.rixsgroup.com"},
      //{"img":"ad_3.jpg", "url":"http://www.suzukirixsauto.com"},
      {"img":"ad_4.jpg", "url":"https://www.facebook.com/euronipponcarsalecenter"},
      {"img":"ad_5.jpg", "url":"https://www.facebook.com/rixslogistics"}
      ];

    Timer.periodic(Duration(seconds: 5), (timer)
    {
      if (isStopped) {
        timer.cancel();
      }
      if (mounted){
        setState(() {
          currentIndex++;
          if (currentIndex >= _ads.length)
            currentIndex = 0;
        });
      }
    });


    super.initState();
  }

  @override
  void deactivate() {
    isStopped=true;
    super.deactivate();
  }

  @override
  Widget build(BuildContext context) {
    return Container(
        padding: const EdgeInsets.only(left: 8.0, right: 8.0, top:0.0, bottom: 64),
        //height: 210,
        child: Wrap(
          children: <Widget>[
            Container(
              width: MediaQuery.of(context).size.width * 1,
              height: 90,
              margin: const EdgeInsets.only(bottom: 2 ),
              child: GestureDetector(
                child: Card(
                    color: Colors.white,
                    elevation: 8,
                    child: Wrap(
                        children: <Widget>[
                          Container(
                              padding: EdgeInsets.only(top: 10, left: MediaQuery.of(context).size.width * 0.05, right: MediaQuery.of(context).size.width * 0.15),
                              child: Image.asset("assets/images/${_ads[currentIndex]["img"]}"),
                          ),
                        ]
                    )
                ),
                onTap: ()async{
                  if (await canLaunch('${_ads[currentIndex]["url"]}')) {
                    await launch('${_ads[currentIndex]["url"]}');
                  } else {
                    throw 'Could not launch ${_ads[currentIndex]["url"]}';
                  }
                },
              ),
            ),
          ],
        )
    );
  }
}