import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:qq_delivery/delivery/config/constant.dart';
import 'package:shared_preferences/shared_preferences.dart';



class SetupPrivateConnection extends StatefulWidget {
  SetupPrivateConnection({Key key, @required this.sharedPrefs}) : super(key: key);
  final SharedPreferences sharedPrefs;

  @override
  _SetupPrivateConnectionState createState() => _SetupPrivateConnectionState( );
}

class _SetupPrivateConnectionState extends State<SetupPrivateConnection> {
  final GlobalKey<ScaffoldState> _scaffoldKey = new GlobalKey<ScaffoldState>();
  Color progressColor = Colors.transparent;
  bool _testURL = false;


  @override
  void initState() {
    super.initState();
    _testURL = getBaseURL(widget.sharedPrefs) == Constant.BASE_URL_DEV;
  }

  @override
  Widget build(BuildContext context) {
    return new WillPopScope(
        onWillPop: _onWillPop,
        child: Scaffold(
          backgroundColor: Theme.of(context).backgroundColor,
          key: _scaffoldKey,
          appBar: AppBar(
//            backgroundColor: Colors.transparent,
            title: Text('Server connection type', style: TextStyle(color: Colors.white)),
            bottom: _createProgressIndicator(),
          ),
          body: Stack(
            fit: StackFit.passthrough,
            children: [

              Center(
                  child: SingleChildScrollView(
                      child: Column(
                          children: <Widget>[
                            Container(
                                padding: const EdgeInsets.only(left: 20.0, top: 20.0, right: 20.0),
                                child:Card(
                                  // color: Colors.white,
                                  elevation: 1,
                                  child: Column(
                                      children: <Widget>[
                                        new Container(
                                          margin: const EdgeInsets.only(top:20, left: 15.0, right: 15.0, bottom: 20),
                                          child: Text('Setting connection',
                                              style: TextStyle(
                                                  // color: Theme.of(context).primaryColor,
                                                  fontWeight: FontWeight.bold,
                                                  fontSize: 18
                                              )),
                                        ),
                                        Container(
                                          padding: const EdgeInsets.all(5.0),
                                          child: ClipOval(
                                              child: Material(
                                                elevation: 8,
                                                // color: Theme.of(context).backgroundColor,
                                                child: InkWell(
                                                  splashColor: Colors.red, // inkwell color
                                                  child: SizedBox(width: 150,
                                                    height: 150,
                                                    child: Icon(Icons.lock, size: 120,),
                                                  ),
                                                ),
                                              )
                                          ),
                                        ),
                                        Container(
                                          margin: const EdgeInsets.only(top: 32.0, left: 16.0, right: 16.0, bottom: 32),
                                          child: new CheckboxListTile(
                                            value: _testURL,
                                            onChanged: ( value) async{
                                              setState(() {
                                                _testURL = value;
                                              });
                                              _setSelectedServer();
                                            },
                                            title: Text(
                                              'Use testing server connection',
                                              // style: new TextStyle(fontSize: 16.0, color: Colors.black),
                                            ),
                                          ),
                                        ),

                                      ]
                                  ),
                                )
                            ),
                          ]
                      )
                  )
              )
            ]
          )
        )
    );
  }

  void _setSelectedServer() async{
    if( _testURL ){
      await setBaseURL( Constant.BASE_URL_DEV );
    }else{
      await setBaseURL( Constant.BASE_URL_PRIMARY );
    }
  }

  PreferredSize _createProgressIndicator() => PreferredSize(
      preferredSize: Size(double.infinity, 4.0),
      child: SizedBox(
          height: 4.0,
          child: LinearProgressIndicator(backgroundColor: progressColor)
      )
  );

  Future<bool> _onWillPop() async {
    return true;
  }

}