

class Attendance{
  int id;
  int facial;
  DateTime inTime;
  String inNote;
  double inLat;
  double inLon;
  String inFace;
  DateTime outTime;
  String outNote;
  double outLat;
  double outLon;
  String outFace;
  String guid;

  Attendance({this.id, this.facial, this.inTime, this.inNote, this.inLat, this.inLon, this.inFace,
    this.outTime, this.outNote, this.outLat, this.outLon, this.outFace, this.guid});

  Map<String, dynamic> toMap() {
    return {
      'id': id,
      'facial': facial,
      'inTime': inTime.millisecondsSinceEpoch,
      'inNote': inNote,
      'inLat': inLat,
      'inLon': inLon,
      'inFace': inFace,
      'outTime': outTime.millisecondsSinceEpoch,
      'outNote': outNote,
      'outLat': outLat,
      'outLon': outLon,
      'outFace': outFace,
      'guid': guid
    };
  }

  fromMap( Map<String, dynamic> data ) async{
    if( data == null) return null;
    return Attendance(
        id: data['id'],
        facial: data['facial'],
        inTime: DateTime.fromMillisecondsSinceEpoch(data['inTime']),
        inNote: data['inNote'],
        inLat: data['inLat'],
        inLon: data['inLon'],
        inFace: data['inFace'],
        outTime: DateTime.fromMillisecondsSinceEpoch(data['outTime']),
        outNote: data['outNote'],
        outLat: data['outLat'],
        outLon: data['outLon'],
        outFace: data['outFace'],
        guid: data['guid']
    );
  }
}