
class Facial{

  static const String STATUS_ACTIVE = "Active";
  static const String STATUS_INACTIVE = "Inactive";

  int id;
  String name;
  String profile;
  String face1;
  String face2;
  String face3;
  String status;
  DateTime createdOn;
  DateTime updatedOn;
  String guid;

  Facial({this.id, this.name, this.profile, this.status, this.createdOn,
    this.updatedOn, this.guid, this.face1, this.face2, this.face3});

  Map<String, dynamic> toMap() {
    return {
      'id': id,
      'name': name,
      'profile': profile,
      'face1': face1,
      'face2': face2,
      'face3': face3,
      'status': status,
      'createdOn': createdOn.millisecondsSinceEpoch,
      'updatedOn': updatedOn.millisecondsSinceEpoch,
      'guid': guid
    };
  }

  Future<Facial> fromMap( Map<String, dynamic> data ) async{

    if( data == null) return null;
    return Facial(
        id: data['id'],
        name: data['name'],
        profile: data['profile'],
        face1: data['face1'],
        face2: data['face2'],
        face3: data['face3'],
        status: data['status'],
        createdOn: DateTime.fromMillisecondsSinceEpoch(data['createdOn']),
        updatedOn: DateTime.fromMillisecondsSinceEpoch(data['updatedOn']),
        guid: data['guid']
    );
  }

  Future<Facial> fromJson( Map<String, dynamic> data ) async{
    if( data == null) return null;
    return Facial(
      name: data["name"],
      profile: data["profile"],
      face1: data['face1'],
      face2: data['face2'],
      face3: data['face3'],
      status: data["status"],
      createdOn: DateTime.parse(data["createdOn"]),
      updatedOn: DateTime.parse(data["updatedOn"]),
      guid: data["guid"]
    );
  }

}