import 'package:equatable/equatable.dart';
import 'package:intl/intl.dart';
import 'dart:convert';


class Employee extends Equatable {

  String department;
  String departmentGUID;
  String supervisor;
  String supervisorGUID;
  String employeeId;
  String firstName;
  String middleName;
  String lastName;
  String nationality;
  DateTime birthday;
  String gender;
  int employmentStatus;
  String jobTitles;
  String jobTitlesGUID;
  DateTime joinedDate;
  DateTime confirmationDate;
  String indirectSupervisors;
  DateTime terminationDate;
  String approver1Name;
  String approver1GUID;
  String approver2Name;
  String approver2GUID;
  String approver3Name;
  String approver3GUID;
  String guid;
  Duration dutyInTime;
  Duration dutyOutTime;
  String status;
  String maritalStatus;
  String ssnNum;
  String nicNum;
  String otherId;
  String drivingLicense;
  DateTime drivingLicenseExpire;
  int payGrade;
  String workStationId;
  String address1;
  String address2;
  String city;
  String country;
  String province;
  String postalCode;
  String homePhone;
  String mobilePhone;
  String workPhone;
  String workEmail;
  String privateEmail;
  String notes;
  int ethnicity;
  int immigrationStatus;
  String facialGUID;
  String userGUID;

  Employee({this.department, this.departmentGUID, this.supervisor, this.supervisorGUID, this.employeeId,
  this.firstName, this.middleName, this.lastName, this.nationality, this.birthday, this.gender, this.employmentStatus,
  this.jobTitles, this.jobTitlesGUID, this.joinedDate, this.confirmationDate, this.indirectSupervisors,
  this.terminationDate, this.approver1Name, this.approver1GUID, this.approver2Name,
  this.approver2GUID, this.approver3Name, this.approver3GUID, this.guid,
  this.dutyInTime, this.dutyOutTime, this.status, this.maritalStatus, this.ssnNum, this.nicNum,
  this.otherId, this.drivingLicense, this.drivingLicenseExpire, this.payGrade, this.workStationId,
  this.address1, this.address2, this.city, this.country, this.province, this.postalCode, this.homePhone,
  this.mobilePhone, this.workPhone, this.workEmail, this.privateEmail, this.notes, this.ethnicity,
  this.immigrationStatus, this.facialGUID, this.userGUID});
  @override
  List<Object> get props => [department, departmentGUID, supervisor, supervisorGUID, employeeId,
    firstName, middleName, lastName, nationality, birthday, gender, employmentStatus,
    jobTitles, jobTitlesGUID, joinedDate, confirmationDate, indirectSupervisors,
    terminationDate, approver1Name, approver1GUID, approver2Name, approver2GUID,
    approver3Name, approver3GUID, guid,
    dutyInTime, dutyOutTime, status, maritalStatus, ssnNum, nicNum,
    otherId, drivingLicense, drivingLicenseExpire, payGrade, workStationId,
    address1, address2, city, country, province, postalCode, homePhone,
    mobilePhone, workPhone, workEmail, privateEmail, notes, ethnicity,
    immigrationStatus, facialGUID, userGUID];
  @override
  String toString() => this.firstName;

  Future<bool> fromJson(String json) async{
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      department = data["department"];
      departmentGUID = data["departmentGUID"];
      supervisor = data["supervisor"];
      supervisorGUID = data["supervisorGUID"];
      employeeId = data["employeeId"];
      firstName = data["firstName"];
      middleName = data["middleName"];
      lastName = data["lastName"];
      nationality = data["nationality"];
      gender = data["gender"];
      employmentStatus = data["employmentStatus"];
      jobTitles = data["jobTitles"];
      jobTitlesGUID = data["jobTitlesGUID"];
      indirectSupervisors = data["indirectSupervisors"];
      approver1Name = data["approver1Name"];
      approver1GUID = data["approver1GUID"];
      approver2Name = data["approver2Name"];
      approver2GUID = data["approver2GUID"];
      approver3Name = data["approver3Name"];
      approver3GUID = data["approver3GUID"];
      guid = data["guid"];
      status = data["status"];
      maritalStatus = data["maritalStatus"];
      ssnNum = data["ssnNum"];
      nicNum = data["nicNum"];
      otherId = data["otherId"];
      drivingLicense = data["drivingLicense"];
      payGrade = data["payGrade"];
      workStationId = data["workStationId"];
      address1 = data["address1"];
      address2 = data["address2"];
      city = data["city"];
      country = data["country"];
      province = data["province"];
      postalCode = data["postalCode"];
      homePhone = data["homePhone"];
      mobilePhone = data["mobilePhone"];
      workPhone = data["workPhone"];
      workEmail = data["workEmail"];
      privateEmail = data["privateEmail"];
      notes = data["notes"];
      ethnicity = data["ethnicity"];
      immigrationStatus = data["immigrationStatus"];
      facialGUID = data["facialGUID"];
      userGUID = data["userGUID"];


      birthday = data["birthday"] != null? DateTime.parse(data["birthday"]) : null;
      joinedDate = data["joinedDate"] != null? DateTime.parse(data["joinedDate"]) : null;
      confirmationDate =data["confirmationDate"] != null? DateTime.parse(data["confirmationDate"]) : null;
      terminationDate =data["terminationDate"] != null? DateTime.parse(data["terminationDate"]) : null;
      drivingLicenseExpire =data["drivingLicenseExpire"] != null? DateTime.parse(data["drivingLicenseExpire"]) : null;

      dutyInTime =data["dutyInTime"]!=null?
      Duration(hours: int.parse(data["dutyInTime"].toString().substring(0, data["dutyInTime"].toString().indexOf(':'))),
          minutes: int.parse(data["dutyInTime"].toString().substring(data["dutyInTime"].toString().indexOf(':') + 1))
      ) : null;

      dutyOutTime = data["dutyOutTime"]!=null?
      Duration(hours: int.parse(data["dutyOutTime"].toString().substring(0, data["dutyOutTime"].toString().indexOf(':'))),
          minutes: int.parse(data["dutyOutTime"].toString().substring(data["dutyOutTime"].toString().indexOf(':') + 1))
      ) : null;

      return true;
    }else{
      return false;
    }
  }

  Map<String, dynamic> toMap(){
    Map<String, dynamic> data = {
    "department" : department,
    "departmentGUID" : departmentGUID,
    "supervisor" : supervisor,
    "supervisorGUID" : supervisorGUID,
    "employeeId" : employeeId,
    "firstName" : firstName,
    "middleName" : middleName,
    "lastName" : lastName,
    "nationality" : nationality,
    "gender" : gender,
    "employmentStatus" : employmentStatus,
    "jobTitles" : jobTitles,
    "jobTitlesGUID" : jobTitlesGUID,
    "indirectSupervisors" : indirectSupervisors,
    "approver1Name" : approver1Name,
    "approver1GUID" : approver1GUID,
    "approver2Name" : approver2Name,
    "approver2GUID" : approver2GUID,
    "approver3Name" : approver3Name,
    "approver3GUID" : approver3GUID,
    "guid" : guid,
    "status" : status,
    "maritalStatus" : maritalStatus,
    "ssnNum" : ssnNum,
    "nicNum" : nicNum,
    "otherId" : otherId,
    "drivingLicense" : drivingLicense,
    "payGrade" : payGrade,
    "workStationId" : workStationId,
    "address1" : address1,
    "address2" : address2,
    "city" : city,
    "country" : country,
    "province" : province,
    "postalCode" : postalCode,
    "homePhone" : homePhone,
    "mobilePhone" : mobilePhone,
    "workPhone" : workPhone,
    "workEmail" : workEmail,
    "privateEmail": privateEmail,
    "notes" : notes,
    "ethnicity" : ethnicity,
    "immigrationStatus" : immigrationStatus,
    "facialGUID" : facialGUID,
    "userGUID" : userGUID,
    "birthday": birthday!=null? new DateFormat('yyyy-MM-dd').format(birthday.toLocal()): null,
    "joinedDate": joinedDate!=null? new DateFormat('yyyy-MM-dd').format(joinedDate.toLocal()): null,
    "confirmationDate": confirmationDate!=null? new DateFormat('yyyy-MM-dd').format(confirmationDate.toLocal()): null,
    "terminationDate": terminationDate!=null? new DateFormat('yyyy-MM-dd').format(terminationDate.toLocal()): null,
    "drivingLicenseExpire": drivingLicenseExpire!=null? new DateFormat('yyyy-MM-dd').format(drivingLicenseExpire.toLocal()): null,
    "dutyInTime" : dutyInTime!=null? "${dutyInTime.inHours.toString().padLeft(2, "0")}:${dutyInTime.inMinutes.remainder(60).toString().padLeft(2, "0")}" :null,
    "dutyOutTime" : dutyOutTime!=null? "${dutyOutTime.inHours.toString().padLeft(2, "0")}:${dutyOutTime.inMinutes.remainder(60).toString().padLeft(2, "0")}" :null
    };

    return data;
  }

}