

import 'dart:convert';
import 'package:equatable/equatable.dart';
import '/hrm/config/constant.dart';
import 'package:shared_preferences/shared_preferences.dart';


class KioskData extends Equatable{
  String guid;
  String deviceGUID;
  String facialGUID;
  String organizationGUID;
  String message;
  bool success;

  KioskData({this.guid, this.deviceGUID, this.facialGUID, this.organizationGUID, this.message, this.success});

  @override
  List<Object> get props => [guid, deviceGUID, facialGUID, organizationGUID, message, success];
  @override
  String toString() => this.guid;


  Future<bool> fromJson(String json, bool save) async{
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];
      guid = data["guid"];
      deviceGUID = data["deviceGUID"];
      facialGUID = data["facialGUID"];
      organizationGUID = data["organizationGUID"];
      message = data["message"];
      success = data["success"];
      if( save && success) {
        SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
        await sharedPrefs.setString(Constant.CURRENT_KIOSK_DATA, json);
      }
      return true;
    }else{
      return false;
    }
  }

  Future<void> fromSharedPreferences() async{
    SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
    if( sharedPrefs.getString(Constant.CURRENT_KIOSK_DATA) != null){
      await fromJson(sharedPrefs.getString(Constant.CURRENT_KIOSK_DATA), false);
    }
  }
}