import 'package:equatable/equatable.dart';

import 'dart:convert';

class Organization extends Equatable {
  String name;
  String guid;
  String plan;
  String status;
  String phone;
  String email;
  String address;
  String contact;
  String hrm;
  int parent;
  String description;
  int country;
  String apiUrl;
  DateTime createdOn;
  Organization({this.name, this.guid, this.plan, this.status, this.phone, this.email, this.address,
    this.contact, this.hrm, this.parent, this.description,
    this.country, this.apiUrl, this.createdOn});
  @override
  List<Object> get props => [name, guid, plan, status, phone, email, address,
    contact, hrm, parent, description, country, apiUrl, createdOn];

  @override
  String toString() => this.name;

  bool fromJson(String json) {
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];
      name = data["name"];
      plan = data["plan"];
      status = data["status"];
      phone = data["phone"];
      email = data["email"];
      address = data["address"];
      contact = data["contact"];
      hrm = data["hrm"];
      parent = data["parent"];
      description = data["description"];
      country = data["country"];
      createdOn = DateTime.parse(data["createdOn"]);// default to utc
      apiUrl = data["apiUrl"];

      return true;
    }else{
      return false;
    }
  }
}