

import 'package:equatable/equatable.dart';
import '/hrm/config/constant.dart';
import 'dart:convert';
import 'package:shared_preferences/shared_preferences.dart';


class User extends Equatable {
  String name;
  String username;
  String email;
  String phone;
  bool active;
  String status;
  String guid;
  String roleName;
  String roleGUID;
  String facialGUID;
  String organizationName;
  String organizationGUID;
  DateTime createdOn;
  DateTime updatedOn;
  String firstName;
  String middleName;
  String lastName;
  String employeeGUID;

User({this.name, this.username, this.email, this.phone, this.active, this.status, this.guid,
  this.roleName, this.roleGUID, this.facialGUID, this.organizationName,
  this.organizationGUID, this.createdOn, this.updatedOn,
  this.firstName, this.middleName, this.lastName, this.employeeGUID});
  @override
  List<Object> get props => [name, email, phone, active, status, guid,
    roleName, roleGUID, facialGUID, organizationName,
    organizationGUID, createdOn, updatedOn, firstName, middleName, lastName, employeeGUID];
  @override
  String toString() => this.name;

  Future<bool> fromJson(String json, bool save) async{
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];
      name = data["name"];
      username = data["username"];
      email = data["email"];
      phone = data["phone"];
      active = data["active"];
      status = data["status"];
      guid = data["guid"];
      roleName = data["roleName"];
      roleGUID = data["roleGUID"];
      facialGUID = data["facialGUID"];
      organizationName = data["organizationName"];
      organizationGUID = data["organizationGUID"];
      createdOn = DateTime.parse(data["createdOn"]);// default to utc
      updatedOn = DateTime.parse(data["updatedOn"]);// default to utc

      if( save) {
        SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
        sharedPrefs.setString(Constant.CURRENT_USER_DATA, json);
      }
      return true;
    }else{
      return false;
    }
  }

  Future<bool> fromJsonEmployee(String json, bool save) async{
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];
      firstName = data["firstName"];
      middleName = data["middleName"];
      lastName = data["lastName"];
      employeeGUID = data["guid"];

      if( save) {
        SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
        sharedPrefs.setString(Constant.CURRENT_USER_DATA_EXT_EMPLOYEE, json);
      }
      return true;
    }else{
      return false;
    }
  }


  Future<void> fromSharedPreferences() async{
    SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
    if( sharedPrefs.getString(Constant.CURRENT_USER_DATA) != null){
      await fromJson(sharedPrefs.getString(Constant.CURRENT_USER_DATA), false);
    }
    if( sharedPrefs.getString(Constant.CURRENT_USER_DATA_EXT_EMPLOYEE) != null){
      await fromJsonEmployee(sharedPrefs.getString(Constant.CURRENT_USER_DATA_EXT_EMPLOYEE), false);
    }
  }
}