import 'package:equatable/equatable.dart';
import 'package:intl/intl.dart';



class AttendanceSearchRequest extends Equatable{
  String employeeName;
  DateTime startDate;
  DateTime endDate;
  int first;
  int max;
  String sharedGUID;

  AttendanceSearchRequest({this.employeeName, this.startDate, this.endDate,
    this.first, this.max, this.sharedGUID});
  @override
  List<Object> get props => [employeeName, startDate, endDate, first, max, sharedGUID];
  @override
  String toString() => '${this.employeeName}';

  Map<String, dynamic> toMap(){
    Map<String, dynamic> data = {
      'employeeName': employeeName,
      'startDate': startDate!=null? new DateFormat('yyyy-MM-dd').format(startDate.toLocal()): null,
      'endDate': endDate!=null? new DateFormat('yyyy-MM-dd').format(endDate.toLocal()) : null,
      'first': first,
      'max':max,
      'sharedGUID':sharedGUID
    };

    return data;
  }
}