import 'package:equatable/equatable.dart';


class FaceRequest extends Equatable{
  static const String TYPE_ADD = "add";
  static const String TYPE_REGISTER = "register";

  String name;
  String organizationGUID;
  String profile;
  List<FaceRequestItem> faces;
  String type;

  FaceRequest({this.name, this.organizationGUID, this.profile, this.faces, this.type});
  @override
  List<Object> get props => [name, organizationGUID, profile, faces, type];

  Map<String, dynamic> toMap(){

    List<Map<String, dynamic>> images = [];
    faces.forEach((element) {
      images.add(element.toMap());
    });

    Map<String, dynamic> data = {
      'name': name,
      'organizationGUID': organizationGUID,
      'profile': profile,
      'faces': images,
      'type': type
    };

    return data;
  }
}


class FaceRequestItem extends Equatable{
  bool flip = false;
  int priority;
  bool preCheck = false;
  String face;

  FaceRequestItem({this.flip, this.priority, this.preCheck, this.face});

  @override
  List<Object> get props => [flip, priority, preCheck, face];

  Map<String, dynamic> toMap(){
    Map<String, dynamic> data = {
      'flip': flip,
      'priority': priority,
      'preChcek': preCheck,
      'face': face
    };
    return data;
  }

}