import 'package:equatable/equatable.dart';
import 'package:intl/intl.dart';



class LeaveApplyRequest extends Equatable{

  String employeeGuid;
  DateTime startDate;
  DateTime endDate;
  String leaveTypeGuid;
  String reason;
  String attachment;
  String leaveDayType;

  LeaveApplyRequest({this.employeeGuid, this.startDate, this.endDate,
    this.leaveTypeGuid, this.reason, this.attachment, this.leaveDayType});
  @override
  List<Object> get props => [employeeGuid, startDate, endDate,
    leaveTypeGuid, reason, attachment, leaveDayType];

  Map<String, dynamic> toMap(){
    Map<String, dynamic> data = {
      'employeeGuid': employeeGuid,
      'startDate': startDate!=null? new DateFormat('yyyy-MM-dd').format(startDate.toLocal()): null,
      'endDate': endDate!=null? new DateFormat('yyyy-MM-dd').format(endDate.toLocal()) : null,
      'leaveTypeGuid': leaveTypeGuid,
      'reason':reason,
      'attachment':attachment,
      'leaveDayType':leaveDayType
    };
    return data;
  }

}