import 'package:equatable/equatable.dart';
import 'package:intl/intl.dart';



class LeaveSearchRequest extends Equatable{

  String status;
  DateTime startDate;
  DateTime endDate;
  String employeeGuid;
  int first;
  int max;
  String employeeName;

  LeaveSearchRequest({this.status, this.startDate, this.endDate, this.employeeGuid,
    this.first, this.max, this.employeeName});
  @override
  List<Object> get props => [status, startDate, endDate, employeeGuid, first, max, employeeName];
  @override
  String toString() => '${this.status}';

  Map<String, dynamic> toMap(){
    Map<String, dynamic> data = {
      'status': status,
      'startDate': startDate!=null? new DateFormat('yyyy-MM-dd').format(startDate.toLocal()): null,
      'endDate': endDate!=null? new DateFormat('yyyy-MM-dd').format(endDate.toLocal()) : null,
      'employeeGuid': employeeGuid,
      'first': first,
      'max':max,
      'employeeName':employeeName
    };

    return data;
  }
}