import 'dart:convert';
import 'package:equatable/equatable.dart';



class AccountBrief extends Equatable {
  String name;
  String userGUID;
  String facialGUID;
  String roleName;

  AccountBrief({this.name, this.userGUID, this.facialGUID, this.roleName});
  @override
  List<Object> get props => [name, userGUID, facialGUID, roleName];
  @override
  String toString() => this.name;

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];
      name = data["name"];
      userGUID = data["userGUID"];
      facialGUID = data["facialGUID"];
      roleName = data["roleName"];
      return true;
    }else{
      return false;
    }
  }

}