import 'dart:convert';
import 'package:equatable/equatable.dart';


class AttendanceDetailResponse extends Equatable {

  String employeeName;
  String facialGUID;
  String departmentName;
  String supervisorName;
  String province;
  String country;
  DateTime inTime;
  String inNote;
  double inLatitude;
  double inLongitude;
  String inIP;
  Duration dutyInTime;
  bool late;
  DateTime outTime;
  String outNote;
  double outLatitude;
  double outLongitude;
  String outIP;
  Duration dutyOutTime;
  bool early;
  DateTime dutyIn;
  DateTime dutyOut;
  int otMinutes;
  String employeeDutyGuid;
  String employeeGuid;
  String employeeId;

  AttendanceDetailResponse({this.employeeName, this.facialGUID,
    this.departmentName, this.supervisorName, this.province, this.country,
    this.inTime, this.inNote, this.inLatitude,
    this.inLongitude, this.inIP, this.dutyInTime, this.late,
    this.outTime, this.outNote, this.outLatitude,
    this.outLongitude, this.outIP, this.dutyOutTime, this.early, this.dutyIn,
    this.dutyOut, this.otMinutes, this.employeeDutyGuid, this.employeeGuid,
    this.employeeId});

  @override
  List<Object> get props => [employeeName, facialGUID, departmentName,
    supervisorName, province, country,
    inTime, inNote, inLatitude, inLongitude, inIP, dutyInTime, late,
    outTime, outNote, outLatitude, outLongitude, outIP, dutyOutTime, early, dutyIn,
    dutyOut, otMinutes, employeeDutyGuid, employeeGuid, employeeId];

  @override
  String toString() => this.employeeName;

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      employeeName = data["employeeName"];
      facialGUID = data["facialGUID"];
      departmentName = data["departmentName"];
      supervisorName = data["supervisorName"];
      province = data["province"];
      country = data["country"];
      inTime = data["inTime"]!=null? DateTime.parse(data["inTime"]) : null;
      inNote = data["inNote"];
      inLatitude = data["inLatitude"];
      inLongitude = data["inLongitude"];
      inIP = data["inIP"];
      outTime = data["outTime"]!=null? DateTime.parse(data["outTime"]) : null;
      outNote = data["outNote"];
      outLatitude = data["outLatitude"];
      outLongitude = data["outLongitude"];
      outIP = data["outIP"];

      dutyInTime =data["dutyInTime"]!=null?
      Duration(hours: int.parse(data["dutyInTime"].toString().substring(0, data["dutyInTime"].toString().indexOf(':'))),
          minutes: int.parse(data["dutyInTime"].toString().substring(data["dutyInTime"].toString().indexOf(':') + 1))
      ) : null;

      dutyOutTime = data["dutyOutTime"]!=null?
      Duration(hours: int.parse(data["dutyOutTime"].toString().substring(0, data["dutyOutTime"].toString().indexOf(':'))),
          minutes: int.parse(data["dutyOutTime"].toString().substring(data["dutyOutTime"].toString().indexOf(':') + 1))
      ) : null;

      late = data["late"];
      early = data["early"];
      dutyIn = data["dutyIn"]!=null? DateTime.parse(data["dutyIn"]) : null;
      dutyOut = data["dutyOut"]!=null? DateTime.parse(data["dutyOut"]) : null;
      otMinutes = data["otMinutes"];
      employeeDutyGuid = data["employeeDutyGuid"];
      employeeGuid = data["employeeGuid"];
      employeeId = data["employeeId"];

      return true;
    }else{
      return false;
    }
  }
}