import 'dart:convert';
import 'package:equatable/equatable.dart';



class AttendanceResponse extends Equatable {
  bool success;
  DateTime dateTime;
  String error;

  AttendanceResponse({this.success, this.dateTime, this.error});
  @override
  List<Object> get props => [success, dateTime, error];
  @override
  String toString() => this.dateTime.toIso8601String();

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];
      success = data["success"];
      dateTime = data["dateTime"] !=null? DateTime.parse(data["dateTime"]) : null;
      error = data["error"];
      return true;
    }else{
      return false;
    }
  }

}