import 'dart:convert';
import 'package:equatable/equatable.dart';



class DepartmentSearchResponse extends Equatable {
  List<DepartmentSearchItem> departments;
  DepartmentSearchResponse({this.departments});
  @override
  List<Object> get props => [departments];
  @override
  String toString() => 'Total records=${this.departments.length}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      final data = resultData["data"] as List;
      departments = new List<DepartmentSearchItem>();
      data.forEach((element) {
        DepartmentSearchItem departmentSearchItem = new DepartmentSearchItem();
        departmentSearchItem.fromMap(element);
        departments.add(departmentSearchItem);
      });
      return true;
    }else{
      return false;
    }
  }
}

class DepartmentSearchItem extends Equatable{
  String name;
  String phone;
  String email;
  String address;
  String description;
  String hrm;
  int country;
  String timezone;
  DateTime createdOn;
  DateTime updatedOn;
  String parentName;
  String guid;
  String parentGUID;

  DepartmentSearchItem({this.name, this.phone, this.email, this.address,
    this.description, this.hrm, this.country, this.timezone, this.createdOn,
    this.updatedOn, this.parentName, this.guid, this.parentGUID});

  @override
  List<Object> get props => [name, phone, email, address,
    description, hrm, country, timezone, createdOn,
    updatedOn, parentName, guid, parentGUID];

  @override
  String toString() => this.name;
  fromMap( Map<String, dynamic> data ){
    guid = data["guid"];
    name = data["name"];
    phone = data["phone"];
    email = data["email"];
    address = data["address"];
    description = data["description"];
    hrm = data["hrm"];
    country = data["country"];
    timezone = data["timezone"];
    createdOn = DateTime.parse(data["createdOn"]);
    updatedOn = DateTime.parse(data["updatedOn"]);
    parentName = data["parentName"];
    parentGUID = data["parentGUID"];
  }

  Map<String, dynamic> toMap(){
    Map<String, dynamic> data = {
      'guid': guid,
      'name': name,
      'phone': phone,
      'email': email,
      'address':address,
      'description':description,
      'hrm':hrm,
      'country':country,
      'timezone':timezone,
//      'createdOn':createdOn,
//      'updatedOn':updatedOn,
//      'parentName': parentName,
//      'parentGUID': parentGUID
    };

    return data;
  }
}