import 'dart:convert';
import 'package:equatable/equatable.dart';



class GeofencingSearchResponse extends Equatable{
  List<GeofencingItem> items;
  int totalRecords;

  GeofencingSearchResponse({this.items, this.totalRecords});
  @override
  List<Object> get props => [items, totalRecords];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

        final geofencings = data["geofencings"] as List;
        items = new List<GeofencingItem>();
        geofencings.forEach((element) {
        GeofencingItem geofencingItem = new GeofencingItem();
        geofencingItem.fromMap(element);
        items.add(geofencingItem);
      });

      totalRecords = data["totalRecords"];
      return true;
    }else{
      return false;
    }
  }

}

class GeofencingItem extends Equatable{
  String organizationName;
  String name;
  int restrictedType;
  DateTime updatedOn;
  String status;
  String action;
  String guid;

  GeofencingItem({this.organizationName, this.name, this.restrictedType, this.updatedOn, this.status, this.action, this.guid});

  @override
  List<Object> get props => [organizationName, name, restrictedType, updatedOn, status, action, guid];

  @override
  String toString() => this.name;

  fromMap( Map<String, dynamic> data ){
    organizationName = data["organizationName"];
    name = data["name"];
    restrictedType = data["restrictedType"];
    updatedOn = data["updatedOn"]!=null? DateTime.parse(data["updatedOn"]) : null;
    status = data["status"];
    action = data["action"];
    guid = data["guid"];
  }
}