import 'dart:convert';
import 'package:equatable/equatable.dart';



class JobTitleListResponse extends Equatable {
  List<JobTitleItem> jobtitles;
  JobTitleListResponse({this.jobtitles});
  @override
  List<Object> get props => [jobtitles];
  @override
  String toString() => 'Total records=${this.jobtitles.length}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      final data = resultData["data"] as List;
      jobtitles = new List<JobTitleItem>();
      data.forEach((element) {
        JobTitleItem jobTitleResponse = new JobTitleItem();
        jobTitleResponse.fromMap(element);
        jobtitles.add(jobTitleResponse);
      });
      return true;
    }else{
      return false;
    }
  }
}

class JobTitleItem extends Equatable{
  String name;
  String code;
  String description;
  String specification;
  String guid;
  String organizationGUID;
  JobTitleItem({this.name, this.code, this.description, this.specification, this.guid, this.organizationGUID});
  @override
  List<Object> get props => [name, code, description, specification, guid, organizationGUID];
  @override
  String toString() => this.name;
  fromMap( Map<String, dynamic> data ){
    name = data["name"];
    code = data["code"];
    description = data["description"];
    specification = data["specification"];
    guid = data["guid"];
    organizationGUID = data["organizationGUID"];
  }
}