import 'dart:convert';
import 'package:equatable/equatable.dart';



class KioskListResponse extends Equatable{
  List<KioskListItem> items;
  int totalRecords;
  bool success;
  String message;


  KioskListResponse({this.items, this.totalRecords, this.success, this.message});
  @override
  List<Object> get props => [items, totalRecords, success, message];
  @override
  String toString() => 'Total records=${this.totalRecords}';

  fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    success = resultData["success"];

    if( success ){
      Map<String, dynamic> data = resultData["data"];

        final geofencings = data["items"] as List;
        items = new List<KioskListItem>();
        geofencings.forEach((element) {
          KioskListItem geofencingItem = new KioskListItem();
          geofencingItem.fromMap(element);
          items.add(geofencingItem);
      });

      totalRecords = data["totalRecords"];
    }else{
      message = resultData["message"];
    }
  }

}

class KioskListItem extends Equatable{

  String token;
  bool active;
  DateTime createdOn;
  DateTime updatedOn;
  String guid;
  String createdBy;
  String usedBy;

  KioskListItem({this.token, this.active, this.createdOn, this.updatedOn, this.guid, this.createdBy, this.usedBy});

  @override
  List<Object> get props => [token, active, createdOn, updatedOn, guid, createdBy, usedBy];

  @override
  String toString() => this.token;

  fromMap( Map<String, dynamic> data ){
    token = data["token"];
    active = data["active"];
    createdOn = data["createdOn"]!=null ? DateTime.parse(data["createdOn"]) : null;
    updatedOn = data["updatedOn"]!=null? DateTime.parse(data["updatedOn"]) : null;
    guid = data["guid"];
    createdBy = data["createdBy"];
    usedBy = data["usedBy"];
  }

}