import 'dart:convert';
import 'package:equatable/equatable.dart';



class LastAttendanceResponse extends Equatable{
  static const String ACTION_IN = "in";
  static const String ACTION_OUT = "out";

  String guid;
  DateTime dateTime;
  String action;
  String note;
  double latitude;
  double longitude;

  LastAttendanceResponse({this.guid, this.dateTime, this.action,
    this.note, this.latitude, this.longitude});

  @override
  List<Object> get props => [guid, dateTime, action, note, latitude, longitude];

  @override
  String toString() => this.guid;

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];
      guid = data["guid"];
      dateTime = DateTime.parse(data["dateTime"]);
      action = data["action"];
      note = data["note"];
      latitude = data["latitude"];
      longitude = data["longitude"];
      return true;
    }else{
      return false;
    }
  }
}