import 'dart:convert';
import 'package:equatable/equatable.dart';



class LeaveApplyResponse extends Equatable{

  List<LeaveApplyItem> leaves;
  double total;
  String status;
  String message;
  bool success;


  LeaveApplyResponse({this.leaves, this.total, this.status});
  @override
  List<Object> get props => [leaves, total, status];
  @override
  String toString() => 'Total records=${this.total}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final attendancesData = data["leaveDays"] as List;
      leaves = new List<LeaveApplyItem>();
      attendancesData.forEach((element) {
        LeaveApplyItem attendanceSearchItem = new LeaveApplyItem();
        attendanceSearchItem.fromMap(element);
        leaves.add(attendanceSearchItem);
      });

      total = data["total"];
      status = data["status"];
      success = true;
      message = resultData["message"];
      return true;
    }else{
      success = false;
      message = resultData["message"];
      total = 0.0;
      return false;
    }
  }
}

class LeaveApplyItem extends Equatable{
  
  static const String STATUS_SUCCESS = "success";
  static const String STATUS_HOLIDAY = "holiday";

  DateTime date;
  String status;
  String type;

  LeaveApplyItem({this.date, this.status, this.type});
  @override
  List<Object> get props => [date, status, type];
  @override
  String toString() => this.status;

  fromMap( Map<String, dynamic> data ){
    date = data["date"]!=null? DateTime.parse(data["date"]) : null;
    status = data["status"];
    type = data["type"];
  }
}