import 'dart:convert';
import 'package:equatable/equatable.dart';



class LeaveBalanceResponse extends Equatable{

  List<LeaveTypeItem> items;
  double totalUsed;
  double totalLeaves;
  String message;
  bool success;


  LeaveBalanceResponse({this.items, this.totalUsed, this.totalLeaves});
  @override
  List<Object> get props => [items, totalUsed, totalLeaves];
  @override
  String toString() => 'Total records=${this.totalLeaves}';

  fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);

    success = resultData["success"];
    if( success ){
      Map<String, dynamic> data = resultData["data"];

      final attendancesData = data["items"] as List;
      items = new List<LeaveTypeItem>();
      attendancesData.forEach((element) {
        LeaveTypeItem attendanceSearchItem = new LeaveTypeItem();
        attendanceSearchItem.fromMap(element);
        items.add(attendanceSearchItem);
      });

      totalUsed = data["totalUsed"];
      totalLeaves = data["totalLeaves"];
    }else{
      message = resultData["message"];
    }
  }
}

class LeaveTypeItem extends Equatable{

  String leaveType;
  double used;
  double pending;
  double rejected;
  double total;
  String leaveTypeGuid;

  LeaveTypeItem({this.leaveType, this.used, this.pending, this.rejected,
    this.total, this.leaveTypeGuid});
  @override
  List<Object> get props => [leaveType, used, pending, rejected, total, leaveTypeGuid];
  @override
  String toString() => this.leaveType;

  fromMap( Map<String, dynamic> data ){
    leaveType = data["leaveType"];
    used = data["used"];
    pending = data["pending"];
    rejected = data["rejected"];
    total = data["total"];
    leaveTypeGuid = data["leaveTypeGuid"];
  }
}