import 'dart:convert';
import 'package:equatable/equatable.dart';
import 'leave_apply_response.dart';
import 'leave_search_response.dart';


class LeaveDetailResponse extends Equatable{

  LeaveSearchItem leaveItem;
  List<LeaveApplyItem> leaves;
  bool success;
  String message;

  LeaveDetailResponse({this.leaveItem, this.leaves, this.success, this.message});
  @override
  List<Object> get props => [leaveItem, leaves, success, message];

   bool fromJson(String json){

    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    success = resultData["success"];
    if( success){
      Map<String, dynamic> data = resultData["data"];
      leaveItem = new LeaveSearchItem();
      leaveItem.fromMap(data['leaveListItem']);

      final leaveDays = data["leaveDays"] as List;
      leaves = new List<LeaveApplyItem>();
      leaveDays.forEach((element) {
        LeaveApplyItem attendanceSearchItem = new LeaveApplyItem();
        attendanceSearchItem.fromMap(element);
        leaves.add(attendanceSearchItem);
      });

    }else{
      message = resultData["message"];
    }

    return true;
  }
}