import 'dart:convert';
import 'package:equatable/equatable.dart';



class LeaveTypeResponse extends Equatable{
  List<LeaveTypeItem> leaveTypes;

  LeaveTypeResponse({this.leaveTypes});
  @override
  List<Object> get props => [leaveTypes];
  @override
  String toString() => 'Total records=${this.leaveTypes.length}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final attendancesData = data["leaveTypes"] as List;
      leaveTypes = new List<LeaveTypeItem>();
      attendancesData.forEach((element) {
        LeaveTypeItem attendanceSearchItem = new LeaveTypeItem();
        attendanceSearchItem.fromMap(element);
        leaveTypes.add(attendanceSearchItem);
      });
      return true;
    }else{
      return false;
    }
  }
}

class LeaveTypeItem extends Equatable{

  String name;
  bool supervisorLeaveAssign;
  bool employeeCanApply;
  bool applyBeyondCurrent;
  String guid;
  double defaultPerYear;
  String organizationGuid;

  LeaveTypeItem({this.name, this.supervisorLeaveAssign, this.employeeCanApply,
    this.applyBeyondCurrent, this.guid, this.defaultPerYear, this.organizationGuid});

  @override
  List<Object> get props => [name, supervisorLeaveAssign, employeeCanApply,
    applyBeyondCurrent, guid, defaultPerYear, organizationGuid];
  @override
  String toString() => this.name;

  fromMap( Map<String, dynamic> data ){
    name = data["name"];
    supervisorLeaveAssign = data["supervisorLeaveAssign"];
    employeeCanApply = data["employeeCanApply"];
    applyBeyondCurrent = data["applyBeyondCurrent"];
    guid = data["guid"];
    defaultPerYear = data["defaultPerYear"];
    organizationGuid = data["organizationGuid"];
  }
}