import 'package:equatable/equatable.dart';
import 'dart:convert';
import '/hrm/database/entity/notification.dart';


class NotificationFetchResponse extends Equatable{

  List<Notification> notifications;
  bool hasNext;

  NotificationFetchResponse({this.notifications, this.hasNext});
  @override
  List<Object> get props => [notifications, hasNext];
  @override
  String toString() => 'Has next=${this.hasNext}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];

      final notificationData = data["notificationItems"] as List;
      notifications = new List<Notification>();
      notificationData.forEach((element) {
        Notification notification = new Notification();
        notification.fromJson(element);
        notifications.add(notification);
      });

      hasNext = data["hasNext"];
      return true;
    }else{
      return false;
    }
  }
}