import 'package:equatable/equatable.dart';
import 'dart:convert';


class NotificationUserSettingsResponse extends Equatable{

  List<NotificationUserSettingsItem> settings;
  NotificationUserSettingsResponse({this.settings});

  @override
  List<Object> get props => [settings];
  @override
  String toString() => 'Total records=${this.settings}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      final settingsData = resultData["data"] as List;
      settings = new List<NotificationUserSettingsItem>();
      settingsData.forEach((element) {
        NotificationUserSettingsItem settingsItem = new NotificationUserSettingsItem();
        settingsItem.fromMap(element);
        settings.add(settingsItem);
      });
      return true;
    }else{
      return false;
    }
  }

}

class NotificationUserSettingsItem extends Equatable{

  static const String ATTENDANCE_IN = "attendance_in";
  static const String ATTENDANCE_OUT = "attendance_out";
  static const String LEAVE_APPLIED = "leave_applied";
  static const String LEAVE_REJECTED = "leave_rejected";
  static const String LEAVE_APPROVED = "leave_approved";
  static const String USER_LOGIN = "user_login";
  static const String USER_LOGOUT = "user_logout";

  String key;
  String value;
  String description;
  String guid;

  NotificationUserSettingsItem({this.key, this.value, this.description, this.guid});
  @override
  List<Object> get props => [key, value, description, guid];
  @override
  String toString() => this.key;

  fromMap( Map<String, dynamic> data ){
    key = data["key"];
    value = data["value"];
    description = data["description"];
    guid = data["guid"];
  }

  Map<String, dynamic> toMap() {
    return {
      'key': key,
      'value': value,
      'description': description,
      'guid': guid
    };
  }

}