import 'dart:convert';
import 'package:equatable/equatable.dart';
import '/hrm/config/constant.dart';
import 'package:shared_preferences/shared_preferences.dart';


class OrganizationDetailResponse extends Equatable {

  static const String ORGANIZATION_STATUS_PENDING = "Pending";
  static const String ORGANIZATION_STATUS_INACTIVE = "Inactive";
  static const String ORGANIZATION_STATUS_ACTIVE = "Active";

  String name;
  String plan;
  String status;
  String phone;
  String email;
  String address;
  String contact;
  String hrm;
  int parent;
  String description;
  int country;
  DateTime createdOn;
  String apiUrl;
  bool success;
  String message;
  String info;

  OrganizationDetailResponse({this.name, this.plan, this.status, this.phone,
    this.email, this.address, this.contact, this.hrm, this.parent,
    this.description, this.country, this.createdOn, this.apiUrl, this.success, this.message});

  @override
  List<Object> get props => [name, plan, status, phone, email, address, contact,
    hrm, parent, description, country, createdOn, apiUrl, success, message];

  @override
  String toString() => this.name;

  fromJson(String json, bool save) async{
    if( json == null) return;

    Map<String, dynamic> resultData = jsonDecode(json);
    success = resultData["success"];

    if( success ){
      Map<String, dynamic> data = resultData["data"];
      name = data["name"];
      plan = data["plan"];
      status = data["status"];
      phone = data["phone"];
      email = data["email"];
      address = data["address"];
      contact = data["contact"];
      hrm = data["hrm"];
      parent = data["parent"];
      description = data["description"];
      country = data["country"];
      createdOn =data["createdOn"]!=null? DateTime.parse(data["createdOn"]):null;
      apiUrl = data["apiUrl"];
      info = data["info"];

    }else{
      message =  resultData["message"];
    }

    try{
      if( save) {
        SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
        sharedPrefs.setString(Constant.CURRENT_ORG_DATA, json);
      }
    }catch (e){}

  }

  Future<void> fromSharedPreferences() async{
    SharedPreferences sharedPrefs = await SharedPreferences.getInstance();
    if( sharedPrefs.getString(Constant.CURRENT_ORG_DATA) != null){
      fromJson(sharedPrefs.getString(Constant.CURRENT_ORG_DATA), false);
    }
  }
}