import 'dart:convert';
import 'package:equatable/equatable.dart';



class OrganizationsByFace extends Equatable {
  List<OrganizationForFace> organizations;
  OrganizationsByFace({this.organizations});
  @override
  List<Object> get props => [organizations];
  @override
  String toString() => 'Total records=${this.organizations.length ?? 0}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      final data = resultData["data"] as List;
      organizations = new List<OrganizationForFace>();
      data.forEach((element) {
        OrganizationForFace organizationForFace = new OrganizationForFace();
        organizationForFace.fromMap(element);
        organizations.add(organizationForFace);
      });
      return true;
    }else{
      return false;
    }
  }
}

class OrganizationForFace extends Equatable{
  String name;
  String guid;
  String status;
  OrganizationForFace({this.name, this.guid, this.status});
  @override
  List<Object> get props => [name, guid, status];
  @override
  String toString() => this.name;
  fromMap( Map<String, dynamic> data ){
    name = data["name"];
    guid = data["guid"];
    status = data["status"];
  }
}