import 'dart:convert';
import 'package:equatable/equatable.dart';



class RecognizeResult extends Equatable {
  bool result;
  String name;
  String faceGUID;
  int faceId;
  double distance;
  Map<String, dynamic> demographic;//age,gender,emotion
  String profile;
  bool enable2FA;

  RecognizeResult({this.result, this.name, this.faceGUID, this.faceId,
    this.distance, this.demographic, this.profile, this.enable2FA});
  @override
  List<Object> get props => [result, name, faceGUID, faceId, distance,
    demographic, profile, enable2FA];
  @override
  String toString() => this.name;

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];
      result = data["result"];
      name = data["name"];
      faceGUID = data["faceGUID"];
      faceId = data["faceId"];
      distance = data["distance"];
      demographic = data["demographic"];
      enable2FA = data["enable2FA"] != null? data["enable2FA"] : false;
      return true;
    }else{
      return false;
    }
  }

}