import 'dart:convert';
import 'package:equatable/equatable.dart';


class Token extends Equatable {
  String accessToken;
  String tokenType;
  String refreshToken;
  int expiresIn;
  String scope;

  Token({this.accessToken, this.tokenType, this.refreshToken, this.expiresIn, this.scope});
  @override
  List<Object> get props => [accessToken, tokenType, refreshToken, expiresIn, scope];
  @override
  String toString() => this.accessToken;

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      Map<String, dynamic> data = resultData["data"];
      accessToken = data["access_token"];
      tokenType = data["token_type"];
      refreshToken = data["refresh_token"];
      expiresIn = data["expires_in"];
      scope = data["scope"];
      return true;
    }else{
      return false;
    }
  }

}