import 'dart:convert';
import 'package:equatable/equatable.dart';


class RoleListResponse extends Equatable {
  List<RoleItem> roles;
  RoleListResponse({this.roles});
  @override
  List<Object> get props => [roles];
  @override
  String toString() => 'Total records=${this.roles.length}';

  bool fromJson(String json){
    if( json == null) return false;
    Map<String, dynamic> resultData = jsonDecode(json);
    if( resultData["success"]){
      final data = resultData["data"] as List;
      roles = new List<RoleItem>();
      data.forEach((element) {
        RoleItem jobTitleResponse = new RoleItem();
        jobTitleResponse.fromMap(element);
        roles.add(jobTitleResponse);
      });
      return true;
    }else{
      return false;
    }
  }
}

class RoleItem extends Equatable{
  String name;
  String guid;
  RoleItem({this.name, this.guid});
  @override
  List<Object> get props => [name, guid];
  @override
  String toString() => this.name;
  fromMap( Map<String, dynamic> data ){
    name = data["name"];
    guid = data["guid"];
  }
}