import 'dart:typed_data';
import 'package:flutter/services.dart';


class Recognition{
  static const MethodChannel _channel = const MethodChannel('plugins.kcc.com/recognition');

  static Future<int> init( ) async {
    return await _channel.invokeMethod( 'init' );
  }

  static Future<Uint8List> template(String base64Image ) async {

    final Map<String, dynamic> params = {'face': base64Image};

    var results = await _channel.invokeMethod('template', params);
    return results;
  }

  static Future<double> matchTemplate(Uint8List base64Image1, Uint8List base64Image2) async {

    final Map<String, dynamic> params = {'face1': base64Image1, 'face2': base64Image2};

    var results = await _channel.invokeMethod('matchTemplate', params);
    return results;
  }

  static Future<int> close( ) async {
    return await _channel.invokeMethod( 'close' );
  }
}