import '/hrm/config/constant.dart';
import '/hrm/model/request/attendance_search_request.dart';
import '/hrm/model/response/attendance_detail_response.dart';
import '/hrm/model/response/attendance_response.dart';
import '/hrm/model/response/attendance_search_response.dart';
import '/hrm/model/response/last_attendance_response.dart';
import 'hrm_base_client.dart';



class AttendanceService{

  Future<LastAttendanceResponse> lastAction( String userAccessToken, String faceGUID) async{

    String _uri = "/v1/attendance/last_action/${faceGUID}";
    String response = await getRequestWithAccessToken(_uri, userAccessToken);

    if( Constant.ENABLE_LOGS)
      print(response);

    LastAttendanceResponse lastAttendanceResponse = new LastAttendanceResponse();
    if( !lastAttendanceResponse.fromJson(response) )
      lastAttendanceResponse = null;

    return lastAttendanceResponse;
  }

  Future<AttendanceResponse> attend(String accessToken, Map<String, dynamic> data) async{
    AttendanceResponse _attendanceResponse;

    String uri = "/v1/attendance/attend";
    String jsonString = await postRequestWithAccessToken(uri, data, accessToken);

    if( Constant.ENABLE_LOGS)
      print(jsonString);

    _attendanceResponse = new AttendanceResponse();
    _attendanceResponse.fromJson(jsonString);
    return _attendanceResponse;
  }

  Future<AttendanceSearchResponse> search(String accessToken, AttendanceSearchRequest request, bool dept) async{
    AttendanceSearchResponse _attendanceResponse;

    String uri = "/v1/attendance/list?dept=${dept}";
    String jsonString = await postRequestWithAccessToken(uri, request.toMap(), accessToken);
    if( Constant.ENABLE_LOGS)
      print(jsonString);

    _attendanceResponse = new AttendanceSearchResponse();
    _attendanceResponse.fromJson(jsonString);
    return _attendanceResponse;
  }

  Future<AttendanceSearchResponse> searchByEmployee(String accessToken, AttendanceSearchRequest request) async{
    AttendanceSearchResponse _attendanceResponse;

    String uri = "/v1/attendance/by_employee";
    String jsonString = await postRequestWithAccessToken(uri, request.toMap(), accessToken);
    if( Constant.ENABLE_LOGS)
      print(jsonString);

    _attendanceResponse = new AttendanceSearchResponse();
    _attendanceResponse.fromJson(jsonString);
    return _attendanceResponse;
  }

  Future<AttendanceDetailResponse> detail( String userAccessToken, String guid) async{

    String _uri = "/v1/attendance/detail/${guid}";
    String response = await getRequestWithAccessToken(_uri, userAccessToken);
    if( Constant.ENABLE_LOGS)
      print(response);

    AttendanceDetailResponse attendanceDetailResponse = new AttendanceDetailResponse();
    attendanceDetailResponse.fromJson( response );

    return attendanceDetailResponse;
  }
}