import 'dart:convert';
import '/hrm/model/response/department_search_response.dart';
import 'hrm_base_client.dart';


class DepartmentService{

  Future<DepartmentSearchResponse> search( String userAccessToken, String parentGuid, String name,[int first, int max]) async{

    if( name == null)
      name = '';
    if( parentGuid == null)
      parentGuid = '';

    if( first == null)
      first = 0;
    if( max == null)
      max = 10000;

    String _uri = "/v1/department/search?name=${name}&guid=${parentGuid}&first=${first}&max=${max}";
    String response = await getRequestWithAccessToken(_uri, userAccessToken);

    DepartmentSearchResponse departmentSearchResponse = new DepartmentSearchResponse();
    departmentSearchResponse.fromJson(response);

    return departmentSearchResponse;
  }

  Future<bool> update( DepartmentSearchItem post, String accessToken) async{

    String _uri = "/v1/department/update";
    String response = await putRequestWithAccessToken( _uri, post.toMap(), accessToken );

    Map<String, dynamic> registerResponse = jsonDecode(response);
    bool success = registerResponse['success'];

    if( success == null){
      return false;
    }

    return success;
  }

  Future<bool> create( String parentGUID, String name, String description, String accessToken) async{

    Map<String, dynamic> deptData = {
      "parentGUID": parentGUID,
      "name": name,
      "description": description
    };

    String _uri = "/v1/department/create";
    String response = await postRequestWithAccessToken( _uri, deptData, accessToken );

    Map<String, dynamic> registerResponse = jsonDecode(response);
    bool success = registerResponse['success'];

    if( success == null){
      return false;
    }

    return success;
  }

}