import 'dart:convert';
import 'dart:io';
import '/hrm/config/constant.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'hrm_base_client.dart';


class DeviceService{

  Future<String> register(String userAccessToken, String userGUID, String firebaseToken) async{

    String deviceGUID;
    Map<String, dynamic> data = {
      "userGUID": userGUID,
      "platform": Platform.isAndroid? Constant.PLATFORM_ANDROID : Constant.PLATFORM_IOS,
      "firebaseToken":firebaseToken
    };

    String uri = "/v1/recogser/device/register";
    String response = await postRequestWithAccessToken(uri, data, userAccessToken);
    Map<String, dynamic> registerResponse = jsonDecode(response);
    bool success = registerResponse['success'];

    if( success == null){
      return null;
    }
    if( success ){
      deviceGUID = registerResponse['data'];
    }

    return deviceGUID;
  }


  Future<void> logout(String userAccessToken) async{
    SharedPreferences sharedPrefs = await SharedPreferences.getInstance();

    Map<String, dynamic> data = {
      "guid": sharedPrefs.getString( Constant.DEVICE_GUID ),
      "firebaseToken": null,
      "logout":true,
      "allowShareAttendance":null
    };
    String uri = "/v1/recogser/device/update";
    String response = await postRequestWithAccessToken(uri, data, userAccessToken);
  }

}