import 'dart:io';
import '/hrm/config/constant.dart';
import '/hrm/imageprocessing/base64image.dart';
import 'package:flutter_image_compress/flutter_image_compress.dart';
import 'package:image/image.dart' as imglib;
import 'face_recognization_service.dart';


class FaceDetectorService{
  // FaceDetector _detector;
  // List<Face> _faces = [];
  bool _isOnlineDetector = true;
  FaceRecognizationService _recognizationService = new FaceRecognizationService( );

  ///
  ///
  void init( ){
    try{
      // _detector =
      //     FirebaseVision.instance.faceDetector(FaceDetectorOptions(
      //       enableTracking: true,
      //       mode: FaceDetectorMode.accurate,
      //     ));
    }catch(e){}
  }

  // Future<List<Face>> _faceDetect(String filePath, bool mounted) async{
  //
  //   try {
  //     List<Face> faces = await _detector.processImage(
  //         FirebaseVisionImage.fromFile(File(filePath)));
  //     if (mounted)
  //         _faces = []..addAll(faces);
  //
  //     _isOnlineDetector = false;
  //   }catch(e){
  //     _isOnlineDetector = true;
  //     if( Constant.ENABLE_LOGS)
  //       print(e);
  //   }
  //   return _faces;
  // }

  Future<DetectionResult> detectedFaceAsBase64String(String tmpDir, String filePath,
      bool mounted, bool deleteOrigin, [bool distanceRequired=true]) async{


    DetectionResult detectionResult;
    String actualDistance;

    if (!mounted) return detectionResult;

    // compressing the image
    File photoFile = new File( filePath );
    if( photoFile.existsSync()) {

      imglib.Image libImageOriginal = imglib.decodeImage( photoFile.readAsBytesSync() );
      int originalHeight = libImageOriginal.width > libImageOriginal.height ? libImageOriginal.width : libImageOriginal.height;

      String photoPath2 = '$tmpDir/${DateTime.now()}-c2.jpg';
      File rotatedFile = await FlutterImageCompress.compressAndGetFile(
        photoFile.absolute.path, photoPath2,
        quality: 90,
        rotate: 0,
      );

      // offline detecting the face
      // await _faceDetect( rotatedFile.absolute.path, mounted );
      // if( _faces.length > 0 ) {
      //   if (!mounted) return detectionResult;
      //
      //
      //   // cropping the face only
      //   Face face = _faces.first;
      //   imglib.Image libImage = imglib.decodeImage( rotatedFile.readAsBytesSync() );
      //
      //   if( distanceRequired ) {
      //     int compressHeight = libImage.height;
      //     int ratio = (compressHeight ~/ originalHeight).toInt();
      //     actualDistance = distance(
      //         (face.boundingBox.width ~/ ratio).toInt(), 'm');
      //   }
      //
      //   imglib.Image croppedImage = copyCrop(
      //       libImage,
      //       face.boundingBox.left.toInt(),
      //       (face.boundingBox.top.toInt()>10 ?face.boundingBox.top.toInt() - 10 : face.boundingBox.top.toInt()),
      //       face.boundingBox.width.toInt(),
      //       face.boundingBox.height.toInt(),
      //       true, 128);
      //
      //   // encoding to base64 string
      //   String cropFilePath = '$tmpDir/${DateTime.now()}-cropped.jpg';
      //   File(cropFilePath)
      //     ..writeAsBytesSync(imglib.encodeJpg(croppedImage, quality: 90));
      //   File smallFile  =File(cropFilePath);
      //   String encodedString = encode(smallFile);
      //   detectionResult = new DetectionResult(
      //       detectedFace: encodedString,
      //       distance: actualDistance,
      //       isOnlineDetector: _isOnlineDetector
      //   );
      //   // deleting processed files
      //   try{
      //     smallFile.deleteSync();
      //   }catch(e){
      //     if( Constant.ENABLE_LOGS)
      //       print('$e');
      //   }
      //
      //   // online server detection
      // }else if( _isOnlineDetector ){

        imglib.Image thumbnail = imglib.copyResize( imglib.decodeImage( rotatedFile.readAsBytesSync()), width: 320);
        String cropFilePath = '$tmpDir/cropped.jpg';
        File(cropFilePath)
          ..writeAsBytesSync(imglib.encodeJpg(thumbnail, quality: 90));
        File smallFile  =File(cropFilePath);
        String base64Image = encode( smallFile );
        String detectedFace = await _recognizationService.faceDetect(base64Image);
        if( detectedFace != null ){
          detectionResult = new DetectionResult(
              detectedFace: detectedFace,
              distance: actualDistance,
              isOnlineDetector: _isOnlineDetector
          );
        }
      // }

      // deleting processed files
      try{
        rotatedFile.deleteSync();
      }catch(e){
        if( Constant.ENABLE_LOGS)
          print('$e');
      }

    }

    // deleting input file
    try{
      if( deleteOrigin)
        photoFile.deleteSync();
    }catch(e){
      if( Constant.ENABLE_LOGS)
        print('$e');
    }

    return detectionResult;
  }

  void dispose() {
    try {
      // if( _detector != null)
      //   _detector.close();
    }catch(e){}
  }
}

class DetectionResult{
  String detectedFace;
  String distance;
  bool isOnlineDetector;

  DetectionResult({this.detectedFace, this.distance, this.isOnlineDetector});
}