import 'dart:io';
import 'dart:math';
import 'dart:typed_data';
import '/hrm/database/dao/facial_dao.dart';
import '/hrm/database/dao/facial_template_dao.dart';
import '/hrm/database/entity/facial.dart';
import '/hrm/database/entity/facial_template.dart';
import '/hrm/model/response/recognize_result.dart';
import '/hrm/plugins/recognition.dart';



@Deprecated('Performance issue')
class RecognitionService{

  bool isInit = false;
  Future<void> init() async{
    if (Platform.isAndroid){
      await Recognition.init( );
      isInit = true;
    }
  }

  Future<void> close() async{
    if (Platform.isAndroid)
      await Recognition.close( );

    isInit = false;
  }

  Future<RecognizeResult> recognize( String base64Image, int facialId ) async{
    int resultId = -1;
    RecognizeResult _recognizeResult;

    if (!Platform.isAndroid)
      return _recognizeResult;

//    await Recognition.init( );
    FacialTemplateDao facialTemplateDao = new FacialTemplateDao();
    await facialTemplateDao.open( );

    Uint8List face = await Recognition.template( base64Image );
    List<FacialTemplate> faces;

    if( facialId != null && facialId > 0 ) {
      faces = await facialTemplateDao.templatesByFacialId(facialId);
    }else {
      faces = await facialTemplateDao.templates( );
    }
    print('Total faces in database = ${faces.length},${face==null} ');

    double result = 0;

    // Random searching
    while(faces.isNotEmpty){
      var ran = new Random();
      int ranNumber = ran.nextInt(faces.length);
      FacialTemplate element = faces.removeAt(ranNumber);
      Uint8List face1ByteArr = element.template;
      try{
        if( face1ByteArr!=null && face != null)
          result = await Recognition.matchTemplate(face1ByteArr, face);
      }catch(e){}
//      print('************************ Count=${i}');
      if( result != null && result > 0){
        resultId = element.facial;
        break;
      }
    }

    /*
    // Linear searching
    for( int i=0; i < faces.length; i++){
      FacialTemplate element = faces[i];
      Uint8List face1ByteArr = element.template;
      try{
        if( face1ByteArr!=null && face != null)
          result = await Recognition.matchTemplate(face1ByteArr, face);
      }catch(e){}
//      print('************************ Count=${i}');
      if( result != null && result > 0){
        resultId = element.facial;
        break;
      }
    }
    */

//    await Recognition.close( );
    await facialTemplateDao.close( );

    if( resultId > 0 ){

      FacialDao facialDao = new FacialDao();
      await facialDao.open( );
      Facial facial = await facialDao.findById(resultId);

        if( facial != null ) {
          _recognizeResult = RecognizeResult(
              result: true,
              name: facial.name,
              faceGUID: facial.guid,
              faceId: facial.id,
              distance: result,
              demographic: null,
              profile: facial.profile
          );
        }
        await facialDao.close();
    }
    return _recognizeResult;
  }

  Future<bool> add( int facialId, String base64Image ) async{
    if ( !Platform.isAndroid )
      return false;

    await Recognition.init( );
    FacialTemplateDao facialTemplateDao = new FacialTemplateDao();
    await facialTemplateDao.open( );

    Uint8List face = await Recognition.template( base64Image );
    if( face != null ) {
      var facialTemplate = FacialTemplate(
          facial: facialId, template: face, createdOn: DateTime
          .now()
          .millisecondsSinceEpoch);
      await facialTemplateDao.insertFacialTemplate(facialTemplate);
    }
    await facialTemplateDao.close( );
    await Recognition.close();

    return true;
  }

  Future<int> remove( int facialId ) async{
    int result = 0;

    if ( !Platform.isAndroid )
      return result;

    FacialTemplateDao facialTemplateDao = new FacialTemplateDao();
    await facialTemplateDao.open( );
    result = await facialTemplateDao.deleteByFacialId(facialId);
    await facialTemplateDao.close( );

    return result;
  }

}