import 'dart:convert';
import '/hrm/config/constant.dart';
import '/hrm/model/response/notification_user_settings_response.dart';
import 'hrm_base_client.dart';



class SettingsService{

  Future<NotificationUserSettingsResponse> fetchNotificationUserSettings(String userAccessToken, String userGuid) async{
    NotificationUserSettingsResponse fetchResponse;

    if( userGuid == null)
      userGuid = '';

    String uri = "/v1/notification_user_settings/fetch?userGuid=$userGuid";
    String jsonString = await getRequestWithAccessToken(uri, userAccessToken);
    if( Constant.ENABLE_LOGS)
      print(jsonString);

    fetchResponse = new NotificationUserSettingsResponse();
    if( !fetchResponse.fromJson(jsonString)){
      fetchResponse = null;
    }

    return fetchResponse;
  }

  Future<bool> updateNotificationUserSettings( NotificationUserSettingsItem settingsItem, String userAccessToken ) async{
    bool result = true;
    if( Constant.ENABLE_LOGS)
      print(json.encode(settingsItem.toMap()));

    String uri = "/v1/notification_user_settings/update";
    String jsonString = await postRequestWithAccessToken(uri, settingsItem.toMap(), userAccessToken);
    if( Constant.ENABLE_LOGS)
      print(jsonString);

    Map<String, dynamic> registerResponse = jsonDecode(jsonString);
    bool success = registerResponse['success'];

    if( success == null || !success ){
      return null;
    }
    return result;
  }


  Future<NotificationUserSettingsItem> saveNotificationUserSettings( NotificationUserSettingsItem settingsItem, String userAccessToken, String userGuid ) async{

    if( userGuid == null)
      userGuid = '';

    if( Constant.ENABLE_LOGS)
      print(json.encode(settingsItem.toMap()));

    String uri = "/v1/notification_user_settings/save?userGuid=$userGuid";
    String jsonString = await postRequestWithAccessToken(uri, settingsItem.toMap(), userAccessToken);
    if( Constant.ENABLE_LOGS)
      print(jsonString);

    Map<String, dynamic> registerResponse = jsonDecode(jsonString);
    bool success = registerResponse['success'];

    if( success == null || !success ){
      return null;
    }

    settingsItem = settingsItem.fromMap(registerResponse['data']);

    return settingsItem;
  }


}