import 'package:flutter/material.dart';



class EditPassword extends StatefulWidget {
  EditPassword({Key key, this.onDispose}) : super(key: key);
  final Function onDispose;
  @override
  _EditPasswordState createState() => _EditPasswordState( );
}

class _EditPasswordState extends State<EditPassword>{
  final GlobalKey<FormState> _formKey = new GlobalKey<FormState>();
  final TextEditingController _controller_pwd = new TextEditingController();
  final TextEditingController _controller_cpwd = new TextEditingController();
  bool _processing = false;

  @override
  initState() {
    super.initState( );
  }

  @override
  Widget build(BuildContext context) {
    return new Form(
      key: _formKey,
      autovalidate: true,
      child: Container(
        padding: const EdgeInsets.only(left: 10.0, top: 10.0, right: 10.0),
        child:Card(
          color: Colors.grey[50],
          elevation: 1,
          child: Container(
            padding: const EdgeInsets.only(left: 10.0, top: 10.0, right: 10.0),
            child:new Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              children: <Widget>[
                new TextFormField(
                  obscureText: true,
                  decoration: const InputDecoration(
                    icon: const Icon(Icons.star),
                    hintText: '',
                    labelText: 'New password',
                  ),
                  controller: _controller_pwd,
                  validator: (val) => val.isEmpty ? 'Password required' :  (val.length<6? 'Minimum password length is 6' : null),
                ),
                new TextFormField(
                  obscureText: true,
                  decoration: const InputDecoration(
                    icon: const Icon(Icons.star),
                    hintText: '',
                    labelText: 'Confirm password',
                  ),
                  controller: _controller_cpwd,
                  validator: (val) => val.isEmpty ? 'Password required' : (val!= _controller_pwd.text ? 'Password does not match!' : null),
                ),
                Container(
                  margin: const EdgeInsets.only(top: 15.0, bottom: 15.0),
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                    children: [
                      _buildButtons( Theme.of(context).primaryColor, Icons.save, 'Save' ),
                      _buildButtons( Colors.transparent, Icons.cancel, 'Cancel'),
                    ],
                  ),
                )
              ]
            )
          )
        )
      )
    );
  }

  Column _buildButtons(Color color, IconData icon, String label) {
    return Column(
      mainAxisSize: MainAxisSize.min,
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        RaisedButton.icon(
          elevation: 2.0,
          icon: Icon(icon, color: Colors.white),
          color: color,
          onPressed:_processing ? null: () async{
            if( label == 'Cancel'){
              widget.onDispose(_controller_cpwd.text, false, '');
            }else{
              final FormState form = _formKey.currentState;
              if (!form.validate()) {
              } else {
                form.save();
                if( _controller_pwd.text.isEmpty){
                  widget.onDispose(_controller_cpwd.text, true, 'Password required!');
                }else if( _controller_pwd.text != _controller_cpwd.text){
                  widget.onDispose(_controller_cpwd.text, true, 'Password does not match!');
                }else
                  widget.onDispose(_controller_cpwd.text, true, 'OK');
              }
            }
          },
          label: Text(
            label,
            style: TextStyle(
              fontSize: 16,
              fontWeight: FontWeight.w400,
              color: Colors.white,
            ),
          ),
        ),
      ],
    );
  }

  bool isValidPhoneNumber(String input) {
    if( input== null || input.isEmpty) return true;
    final RegExp regex = new RegExp(r'(?:[0-9]\d{10,13})$');//new RegExp(r'^\(\d\d\d\)\d\d\d\-\d\d\d\d$');
    return regex.hasMatch(input);
  }

  bool isValidEmail(String input) {
    if( input==null || input.isEmpty) return true;
    final RegExp regex = new RegExp(r"^[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,253}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,253}[a-zA-Z0-9])?)*$");
    return regex.hasMatch(input);
  }

}