
import 'package:flutter/material.dart';


class ThemeChanger extends ChangeNotifier {
  ThemeData _themeData;
  ThemeChanger(this._themeData);

  get getTheme => _themeData;
  void setTheme(ThemeData theme) {
    _themeData = theme;
    notifyListeners();
  }
}

var darkTheme = ThemeData.dark();
var orangeTheme= ThemeData(
  brightness: Brightness.light,
  primarySwatch: orangeColorCustom,
  accentColor: orangeColorCustom,
  buttonColor: orangeColorCustom[600],
  backgroundColor: new Color(0xFFF4F6F8),
  // primaryColorDark: new Color(0xFFdb9300),
  primaryColorDark: new Color(0xFFe65100),
  fontFamily: 'Roboto:300,400,500',
  textTheme: TextTheme(
    headline1: TextStyle(fontSize: 72.0, fontWeight: FontWeight.bold),
    bodyText2: TextStyle(fontSize: 14.0, fontFamily: 'Roboto'),
    headline6: TextStyle(fontSize: 18.0, fontStyle: FontStyle.normal, color: Colors.black),
    // headline6: TextStyle(fontSize: 18.0, fontStyle: FontStyle.normal, color: new Color(0xFFdb9300)),
    // headline6: TextStyle(fontSize: 18.0, fontStyle: FontStyle.normal, color: new Color(0xFF005300)),
    headline5: TextStyle(fontSize: 20.0, fontStyle: FontStyle.normal, color: Colors.white, fontWeight: FontWeight.normal, fontFamily: 'Roboto'),
  ),
  //canvasColor: colorCustom
);
var goldTheme= ThemeData(
  brightness: Brightness.light,
  primarySwatch: goldColorCustom,
  accentColor: goldColorCustom,
  buttonColor: goldColorCustom[600],
  backgroundColor: new Color(0xFFF4F6F8),
  // primaryColorDark: new Color(0xFFdb9300),
  primaryColorDark: new Color(0xFFe65100),
  fontFamily: 'Roboto:300,400,500',
  textTheme: TextTheme(
    headline1: TextStyle(fontSize: 72.0, fontWeight: FontWeight.bold),
    bodyText2: TextStyle(fontSize: 14.0, fontFamily: 'Roboto'),
    headline6: TextStyle(fontSize: 18.0, fontStyle: FontStyle.normal, color: Colors.black),
    // headline6: TextStyle(fontSize: 18.0, fontStyle: FontStyle.normal, color: new Color(0xFFdb9300)),
    // headline6: TextStyle(fontSize: 18.0, fontStyle: FontStyle.normal, color: new Color(0xFF005300)),
    headline5: TextStyle(fontSize: 20.0, fontStyle: FontStyle.normal, color: Colors.white, fontWeight: FontWeight.normal, fontFamily: 'Roboto'),
  ),
  //canvasColor: colorCustom
);
var greenTheme= ThemeData(
  brightness: Brightness.light,
  primarySwatch: greenColorCustom,
  accentColor: greenColorCustom,
  buttonColor: greenColorCustom[600],
  backgroundColor: new Color(0xFFF4F6F8),
  // primaryColorDark: new Color(0xFFdb9300),
  primaryColorDark: new Color(0xFFe65100),
  fontFamily: 'Roboto:300,400,500',
  textTheme: TextTheme(
    headline1: TextStyle(fontSize: 72.0, fontWeight: FontWeight.bold),
    bodyText2: TextStyle(fontSize: 14.0, fontFamily: 'Roboto'),
    headline6: TextStyle(fontSize: 18.0, fontStyle: FontStyle.normal, color: Colors.black),
    // headline6: TextStyle(fontSize: 18.0, fontStyle: FontStyle.normal, color: new Color(0xFFdb9300)),
    // headline6: TextStyle(fontSize: 18.0, fontStyle: FontStyle.normal, color: new Color(0xFF005300)),
    headline5: TextStyle(fontSize: 20.0, fontStyle: FontStyle.normal, color: Colors.white, fontWeight: FontWeight.normal, fontFamily: 'Roboto'),
  ),
  //canvasColor: colorCustom
);
var redTheme= ThemeData(
  brightness: Brightness.light,
  primarySwatch: redColorCustom,
  accentColor: redColorCustom,
  buttonColor: redColorCustom[600],
  backgroundColor: new Color(0xFFF4F6F8),
  // primaryColorDark: new Color(0xFFdb9300),
  primaryColorDark: new Color(0xFFe65100),
  fontFamily: 'Roboto:300,400,500',
  textTheme: TextTheme(
    headline1: TextStyle(fontSize: 72.0, fontWeight: FontWeight.bold),
    bodyText2: TextStyle(fontSize: 14.0, fontFamily: 'Roboto'),
    headline6: TextStyle(fontSize: 18.0, fontStyle: FontStyle.normal, color: Colors.black),
    // headline6: TextStyle(fontSize: 18.0, fontStyle: FontStyle.normal, color: new Color(0xFFdb9300)),
    // headline6: TextStyle(fontSize: 18.0, fontStyle: FontStyle.normal, color: new Color(0xFF005300)),
    headline5: TextStyle(fontSize: 20.0, fontStyle: FontStyle.normal, color: Colors.white, fontWeight: FontWeight.normal, fontFamily: 'Roboto'),
  ),
  //canvasColor: colorCustom
);
var blueTheme= ThemeData(
  brightness: Brightness.light,
  primarySwatch: blueColorCustom,
  accentColor: blueColorCustom,
  buttonColor: blueColorCustom[600],
  backgroundColor: new Color(0xFFF4F6F8),
  // primaryColorDark: new Color(0xFFdb9300),
  primaryColorDark: new Color(0xFFe65100),
  fontFamily: 'Roboto:300,400,500',
  textTheme: TextTheme(
    headline1: TextStyle(fontSize: 72.0, fontWeight: FontWeight.bold),
    bodyText2: TextStyle(fontSize: 14.0, fontFamily: 'Roboto'),
    headline6: TextStyle(fontSize: 18.0, fontStyle: FontStyle.normal, color: Colors.black),
    // headline6: TextStyle(fontSize: 18.0, fontStyle: FontStyle.normal, color: new Color(0xFFdb9300)),
    // headline6: TextStyle(fontSize: 18.0, fontStyle: FontStyle.normal, color: new Color(0xFF005300)),
    headline5: TextStyle(fontSize: 20.0, fontStyle: FontStyle.normal, color: Colors.white, fontWeight: FontWeight.normal, fontFamily: 'Roboto'),
  ),
  //canvasColor: colorCustom
);

MaterialColor orangeColorCustom = MaterialColor(0xFFef6c00, colorOrange);
Map<int, Color> colorOrange = {
  50:Color.fromRGBO(239, 108, 0, .1),
  100:Color.fromRGBO(239, 108, 0, .2),
  200:Color.fromRGBO(239, 108, 0, .3),
  300:Color.fromRGBO(239, 108, 0, .4),
  400:Color.fromRGBO(239, 108, 0, .5),
  500:Color.fromRGBO(239, 108, 0, .6),
  600:Color.fromRGBO(239, 108, 0, .7),
  700:Color.fromRGBO(239, 108, 0, .8),
  800:Color.fromRGBO(239, 108, 0, .9),
  900:Color.fromRGBO(239, 108, 0, 1),
};

MaterialColor goldColorCustom = MaterialColor(0xFFfaa300, colorGold);
Map<int, Color> colorGold = {
  50:Color.fromRGBO(250,163,0, .1),
  100:Color.fromRGBO(250,163,0, .2),
  200:Color.fromRGBO(250,163,0, .3),
  300:Color.fromRGBO(250,163,0, .4),
  400:Color.fromRGBO(250,163,0, .5),
  500:Color.fromRGBO(250,163,0, .6),
  600:Color.fromRGBO(250,163,0, .7),
  700:Color.fromRGBO(250,163,0, .8),
  800:Color.fromRGBO(250,163,0, .9),
  900:Color.fromRGBO(250,163,0, 1),
};

MaterialColor greenColorCustom = MaterialColor(0xFF006300, colorGreen);
Map<int, Color> colorGreen = {
  50:Color.fromRGBO(0,99,0, .1),
  100:Color.fromRGBO(0,99,0, .2),
  200:Color.fromRGBO(0,99,0, .3),
  300:Color.fromRGBO(0,99,0, .4),
  400:Color.fromRGBO(0,99,0, .5),
  500:Color.fromRGBO(0,99,0, .6),
  600:Color.fromRGBO(0,99,0, .7),
  700:Color.fromRGBO(0,99,0, .8),
  800:Color.fromRGBO(0,99,0, .9),
  900:Color.fromRGBO(0,99,0, 1),
};

MaterialColor redColorCustom = MaterialColor(0xFFed1c24, colorRed);
Map<int, Color> colorRed = {
  50:Color.fromRGBO(237, 28, 36, .1),
  100:Color.fromRGBO(237, 28, 36, .2),
  200:Color.fromRGBO(237, 28, 36, .3),
  300:Color.fromRGBO(237, 28, 36, .4),
  400:Color.fromRGBO(237, 28, 36, .5),
  500:Color.fromRGBO(237, 28, 36, .6),
  600:Color.fromRGBO(237, 28, 36, .7),
  700:Color.fromRGBO(237, 28, 36, .8),
  800:Color.fromRGBO(237, 28, 36, .9),
  900:Color.fromRGBO(237, 28, 36, 1),
};

MaterialColor blueColorCustom = MaterialColor(0xFF2b55bc, colorBlue);
Map<int, Color> colorBlue = {
  50:Color.fromRGBO(43, 85, 188, .1),
  100:Color.fromRGBO(43, 85, 188, .2),
  200:Color.fromRGBO(43, 85, 188, .3),
  300:Color.fromRGBO(43, 85, 188, .4),
  400:Color.fromRGBO(43, 85, 188, .5),
  500:Color.fromRGBO(43, 85, 188, .6),
  600:Color.fromRGBO(43, 85, 188, .7),
  700:Color.fromRGBO(43, 85, 188, .8),
  800:Color.fromRGBO(43, 85, 188, .9),
  900:Color.fromRGBO(43, 85, 188, 1),
};